{$ifdef fpc}{$smartlink on}{$endif}
{$n+}
unit bilbo;
interface
{$ifdef win32}uses windows;{$endif}

type
 {$ifndef win32}
 u_val=word;
 smallint=integer;
 DWord=longint;
 Int64=Comp;
 {$else}
 {$ifdef ver140}
 u_val=dword;
 {$else}
 Int64=Comp;
 u_val=integer;
 {$ifndef fpc}DWord=integer;{$endif}
 {$endif}
 {$endif}
 a0=array[0..0] of byte;
 p0=^a0;
 a0i=array[0..0] of integer;
 p0i=^a0i;
 a0l=array[0..0] of longint;
 p0l=^a0l;
 a0s=array[0..0] of string;
 p0s=^a0s;
{$ifndef win32}{$ifndef linux}
 shortstring=string;
{$endif}{$endif}
 w4rec=packed record
  d,c,b,a:byte;
 end;

{$ifdef win32}{$ifdef fpc}
{Opravy spatnych funkci v FPC}
type BOOL=LongBool;
function ChooseColor(var CC:TChooseColor):Bool;stdcall;
function TrackPopupMenu(hMenu:HMENU;uFlags:UINT;x,y,nReserved:Integer;hWnd:HWND;
 prcRect:PRect):BOOL;stdcall;
function getopenfilename(var o_f:topenfilename):bool;stdcall;
function getsavefilename(var o_f:topenfilename):bool;stdcall;
function CreateFont(nHeight,nWidth,nEscapement,nOrientaion,fnWeight:Integer;fdwItalic,
 fdwUnderline,fdwStrikeOut,fdwCharSet,fdwOutputPrecision,fdwClipPrecision,fdwQuality,
 fdwPitchAndFamily:DWORD;lpszFace:PChar):HFONT;stdcall;
function GetWindowPlacement(hWnd:HWND;WindowPlacement:PWindowPlacement):BOOL;stdcall;
function InvalidateRect(hWnd:HWND;lpRect:PRect;bErase:BOOL):BOOL;stdcall;
procedure GetSystemTimeAsFileTime(var lpSystemTimeAsFileTime:TFileTime);stdcall;
function RedrawWindow(hWnd:HWND;lprcUpdate:PRect;hrgnUpdate:HRGN;flags:UINT):BOOL;stdcall;
{$endif}{$endif}

function fmt(s:string;len:integer):string;
function fmt0(s:string;len:integer):string;
function bswap(X:longint):longint;

procedure fatal(const s:string);
procedure getzero(var p;i:u_val);
function addslashes(const s:string):string;
{$ifndef win32}{$ifndef linux}
procedure setlength(var s:shortstring;l:integer);
{$endif}{$endif}
function pos_i(const s,t:string):integer;
function locase(c:char):char;
function s_locase(s:string):string;
function s_upcase(s:string):string;
procedure str_locase(var s:string);
procedure str_upcase(var s:string);
function strl(n:longint):string;
function hexl(w:longint):string;
function hexw(w:word):string;
function hexb(b:byte):string;
function stre(n:extended;i,j:integer):string;
function strl2(n:longint;i:integer):string;
function strl0(n:longint;i:integer):string;
function str_ip(l:longint):string;
function count(s:string;cc:char):integer;
function trim(s:string):string;
function beginwith(a:string;b:string):boolean;
function beginwithi(a:string;b:string):boolean;
function strlen(x:pchar):integer;


{$ifdef win32}
const
 BIF_RETURNONLYFSDIRS   =$0001;
 BIF_DONTGOBELOWDOMAIN  =$0002;
 BIF_STATUSTEXT         =$0004;
 BIF_RETURNFSANCESTORS  =$0008;

 BIF_BROWSEFORCOMPUTER  =$1000;
 BIF_BROWSEFORPRINTER   =$2000;
 BIF_BROWSEINCLUDEFILES =$4000;

 ICON_SMALL=0;
 ICON_BIG  =1;

 EXCEPTION_EXECUTE_HANDLER=1;
 EXCEPTION_CONTINUE_EXECUTION=-1;
 EXCEPTION_CONTINUE_SEARCH=0;

{$endif}

implementation

{$ifdef win32}{$ifdef fpc}
function TrackPopupMenu;external 'user32.dll' name 'TrackPopupMenu';
function ChooseColor;external 'comdlg32.dll' name 'ChooseColorA';
function GetOpenFileName;external 'comdlg32.dll' name 'GetOpenFileNameA';
function GetSaveFileName;external 'comdlg32.dll' name 'GetSaveFileNameA';
function CreateFont;external 'gdi32.dll' name 'CreateFontA';
function GetWindowPlacement;external 'user32.dll' name 'GetWindowPlacement';
function InvalidateRect;external 'user32.dll' name 'InvalidateRect';
procedure GetSystemTimeAsFileTime;external 'kernel32.dll' name 'GetSystemTimeAsFileTime';
function RedrawWindow;external 'user32.dll' name 'RedrawWindow';
{$endif}{$endif}

function fmt(s:string;len:integer):string;
begin
 while length(s)<len do s:=' '+s;
 if length(s)>len then s:=copy(s,1,len);
 fmt:=s;
end;

function fmt0(s:string;len:integer):string;
begin
 while length(s)<len do s:='0'+s;
 if length(s)>len then s:=copy(s,1,len);
 fmt0:=s;
end;

function bswap(X:longint):longint;
var
 y:longint;
begin
 w4rec(y).d:=w4rec(x).a;
 w4rec(y).c:=w4rec(x).b;
 w4rec(y).b:=w4rec(x).c;
 w4rec(y).a:=w4rec(x).d;
 bswap:=y;
end;

procedure fatal(const s:string);
begin
 writeln(s);
 halt;
end;

procedure getzero(var p;i:u_val);
begin
 getmem(pointer(p),i);
 fillchar(pointer(p)^,i,0);
end;

{$ifdef fpc}{$asmmode intel}{$endif}
{$ifndef win32}{$ifndef linux}
procedure setlength(var s:shortstring;l:integer);
begin
 s[0]:=chr(l);
end;
{$endif}{$endif}

function pos_i(const s,t:string):integer;
begin
 pos_i:=pos(s_locase(s),s_locase(t));
end;

function addslashes(const s:string):string;
var
 t:string;
 i:integer;
begin
 fillchar(t,sizeof(t),0);
 if length(s)=0 then begin
  addslashes:=s;
  exit;
 end;
 for i:=1 to length(s) do begin
  if s[i] in ['\','"',''''] then t:=t+'\';
  t:=t+s[i];
 end;
 addslashes:=t;
 i:=0;
end;


{$ifdef linux}
function locase(c:char):char;
begin
 if c in ['A'..'Z'] then dec(c,ord('A')-ord('a'));
 locase:=c;
end;

{$else}

function locase(c:char):char;assembler;
asm
 mov al,c
 cmp al,'A'
 jb  @1
 cmp al,'Z'
 ja  @1
 sub al,'A'-'a'
@1:
end;

{$endif}

function s_locase(s:string):string;
var
 q:pointer;
 {$ifndef win32}i,{$endif}l:integer;
begin
 l:=length(s);
 {$ifndef win32}
 i:=1;
 while(i<=l) do begin
  s[i]:=locase(s[i]);
  inc(i);
 end;
 {$else}
 q:=(@s[1]);
 asm
  push esi
  push eax
  push edx
  mov esi,q
  mov edx,l
  dec edx
  add edx,esi
 @0:
  cmp esi,edx
  jg @2
  mov al,[esi]
  cmp al,'A'
  jb  @1
  cmp al,'Z'
  ja  @1
  sub al,'A'-'a'
 @1:
  mov [esi],al
  inc esi
  jmp @0
 @2:
  pop edx
  pop eax
  pop esi
 end;
 {$endif}
 s_locase:=s;
end;

function s_upcase(s:string):string;
var
 q:pointer;
 {$ifndef win32}i,{$endif}l:integer;
begin
 l:=length(s);
 {$ifndef win32}
 i:=1;
 while(i<=l) do begin
  s[i]:=upcase(s[i]);
  inc(i);
 end;
 {$else}
 q:=(@s[1]);
 asm
  push esi
  push eax
  push edx
  mov esi,q
  mov edx,l
  dec edx
  add edx,esi
 @0:
  cmp esi,edx
  jg @2
  mov al,[esi]
  cmp al,'a'
  jb  @1
  cmp al,'z'
  ja  @1
  sub al,'a'-'A'
 @1:
  mov [esi],al
  inc esi
  jmp @0
 @2:
  pop edx
  pop eax
  pop esi
 end;
 {$endif}
 s_upcase:=s;
end;

procedure str_locase(var s:string);
var
 {$ifndef win32}i,{$endif}l:integer;
 q:pointer;
begin
 l:=length(s);
 {$ifndef win32}
 i:=1;
 while(i<=l) do begin
  s[i]:=locase(s[i]);
  inc(i);
 end;
 {$else}
 q:=(@s[1]);
 asm
  push esi
  push eax
  push edx
  mov esi,q
  mov edx,l
  dec edx
  add edx,esi
 @0:
  cmp esi,edx
  jg @2
  mov al,[esi]
  cmp al,'A'
  jb  @1
  cmp al,'Z'
  ja  @1
  sub al,'A'-'a'
 @1:
  mov [esi],al
  inc esi
  jmp @0
 @2:
  pop edx
  pop eax
  pop esi
 end;
 {$endif}
end;

procedure str_upcase(var s:string);
var i,l:integer;
begin
 i:=1;
 l:=length(s);
 while(i<=l) do begin
  s[i]:=upcase(s[i]);
  inc(i);
 end;
end;

function strl(n:longint):string;
var s:string[12];
begin
 system.str(n,s);
 strl:=s;
end;

const
 hCh:array [0..$F] of Char='0123456789ABCDEF';
function hexl(w:longint):string;
begin
 hexl:=
 hCh[w4rec(w).a shr 4]+hCh[w4rec(w).a and $F]+
 hCh[w4rec(w).b shr 4]+hCh[w4rec(w).b and $F]+
 hCh[w4rec(w).c shr 4]+hCh[w4rec(w).c and $F]+
 hCh[w4rec(w).d shr 4]+hCh[w4rec(w).d and $F];
end;

function hexw(w:word):string;
begin
 hexw:=
 hCh[hi(w) shr 4]+hCh[hi(w) and $F]+
 hCh[lo(w) shr 4]+hCh[lo(w) and $F];
end;

function hexb(b:byte):string;
begin
 hexb:=hCh[b shr 4]+hCh[b and $F];
end;

function stre(n:extended;i,j:integer):string;
var s:string;
begin
 fillchar(s,sizeof(s),0);
 system.str(n:i:j,s);
 stre:=s;
end;

function strl2(n:longint;i:integer):string;
var s:string[12];
begin
 system.str(n:i,s);
 strl2:=s;
end;

function strl0(n:longint;i:integer):string;
var s:string[12];
begin
 system.str(n,s);
 strl0:=fmt0(s,i);
end;

function str_ip(l:longint):string;
type
 bb=array[0..3] of byte;
begin
{ if l=$ffffffff then str_ip:='Invalid'
 else }str_ip:=strl(bb(l)[3])+'.'+strl(bb(l)[2])+'.'+strl(bb(l)[1])+'.'+strl(bb(l)[0]);
end;

function count(s:string;cc:char):integer;
var
 c,i,l:integer;
begin
 l:=length(s);
 i:=1;c:=0;
 while i<=l do begin
  if s[i]=cc then inc(c);
  inc(i);
 end;
 count:=c; 
end;

function trim(s:string):string;
var i,l:integer;
begin
 l:=length(s);
 if l=0 then begin
  trim:='';
  exit;
 end;
 i:=1;
 while (i<l) and (s[i] in [' ',#10,#13]) do inc(i);
 if i>1 then s:=copy(s,i,l);
 l:=length(s);
 if l=0 then begin
  trim:='';
  exit;
 end;
 i:=l;
 while (i>0) and (s[i] in [' ',#10,#13]) do dec(i);
 if i<l then setlength(s,i);
 trim:=s;
end;

function beginwith(a:string;b:string):boolean;
var
 i:integer;
begin
 if length(a)<length(b) then beginwith:=false
 else begin
  for i:=1 to length(b) do
  if (a[i]<>b[i]) then begin
   beginwith:=false;
   exit;
  end;
  beginwith:=true;
 end;
end;

function beginwithi(a:string;b:string):boolean;
var
 i:integer;
begin
 if length(a)<length(b) then beginwithi:=false
 else begin
  for i:=1 to length(b) do
  if (locase(a[i])<>locase(b[i])) then begin
   beginwithi:=false;
   exit;
  end;
  beginwithi:=true;
 end;
end;

function strlen(x:pchar):integer;
var
 i:integer;
begin
 i:=0;
 if x=nil then strlen:=0 else begin
  while x^<>#0 do begin
   inc(i);
   inc(x);
  end;
 end;
 strlen:=0;
end;

end.