{$ifndef mod_config}
 ERROR: mod_exec requires mod_config
{$endif}
{$define mod_exec}

const
 DUPLICATE_CLOSE_SOURCE=$00000001;
 DUPLICATE_SAME_ACCESS =$00000002;

function startexec(var ss:send_struct;const filename,App,Param:ansistring;var ProcessInfo:TProcessInformation;var error:ansistring;extradata:boolean;var result2:thandle;const cdir:string):thandle;
var
 StartupInfo:TStartupInfo;
 SecurityAttributes:TSecurityAttributes;
 TempHandle,WriteHandle,ReadHandle,stdinhandle,posthandle:thandle;
 CommandLine:ansistring;

function SysErrorMessage(ErrorCode:Integer):ansistring;
var
 Len:Integer;
 Buffer:array[0..255] of Char;
begin
 Len:=FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_ARGUMENT_ARRAY,nil,ErrorCode,0,Buffer,SizeOf(Buffer),nil);
 while (Len>0) and (Buffer[Len-1] in [#0..#32,'.']) do Dec(Len);
 Setstring(Result,Buffer,Len);
end;

procedure errmsg;
begin
 error:=SysErrorMessage(GetLastError);
end;

function allheaders(var ss:send_struct):ansistring;
var
 i,j,l:integer;
 res,line,name:string;
begin
 allheaders:='';
 i:=pos(#10,ss.req)+1;
 if i=1 then exit;
 while getline(ss.req,i,line) do begin
  j:=pos(':',line);
  if j>0 then begin
   name:='HTTP_'+s_upcase(trim(copy(line,1,j-1)));
   for l:=1 to length(name) do if name[l]='-' then name[l]:='_';
   if (name='HTTP_CONTENT_LENGTH') then name:='CONTENT_LENGTH';
   if (name='HTTP_CONTENT_TYPE') then name:='CONTENT_TYPE';
   if not((name='HTTP_AUTHORIZATION') and ss.verified) then begin
    res:=res+#0+name+'='+trim(copy(line,j+1,$7fffffff));
   end;
  end;
 end;
 allheaders:=res;
end;

var
 OSVersionInfo:TOSVersionInfo;
 win32platform:integer;
 env{,curdir}:pointer;
 q,s_env:string;
 en,hp:pchar;

function inherithandle(var h:thandle):boolean;
begin
 if Win32Platform=VER_PLATFORM_WIN32_NT then begin
  if not(SetHandleInformation(H,HANDLE_FLAG_INHERIT,0)) then begin
   result:=false;
   exit;
  end;
 end else begin
  if not(DuplicateHandle(GetCurrentProcess,h,GetCurrentProcess,@TempHandle,0,True,DUPLICATE_SAME_ACCESS)) then begin
   result:=false;
   exit;
  end;
  CloseHandle(h);
  h:=TempHandle;
 end;
 result:=true;
end;

var
 ccdir:pointer;
begin
 result:=invalid_handle_value;
 result2:=invalid_handle_value;
 OSVersionInfo.dwOSVersionInfoSize:=SizeOf(OSVersionInfo);
 if GetVersionEx(OSVersionInfo) then Win32Platform:=OSVersionInfo.dwPlatformId else win32platform:=0;
 commandline:='"'+App+'" '+Param;
 FillChar(StartupInfo,SizeOf(StartupInfo),0);
 FillChar(SecurityAttributes,SizeOf(SecurityAttributes),0);
 with SecurityAttributes do begin
  nLength:=Sizeof(SecurityAttributes);
  bInheritHandle:=true;
 end;
 if not(CreatePipe(ReadHandle,WriteHandle,@SecurityAttributes,0)) then begin
  errmsg;
  exit;
 end;
 if not(inherithandle(ReadHandle)) then begin
  errmsg;
  exit;
 end;
 if extradata then begin
  if not(CreatePipe(stdinHandle,postHandle,@SecurityAttributes,0)) then begin
   errmsg;
   exit;
  end;
  if not(inherithandle(postHandle)) then begin
   errmsg;
   exit;
  end;
 end;
 with StartupInfo do begin
  cb:=SizeOf(StartupInfo);
  dwFlags:=STARTF_USESTDHANDLES or STARTF_USESHOWWINDOW;
  wShowWindow:=SW_HIDE;
  if extradata then hStdInput:=stdinHandle;
  hStdOutput:=WriteHandle;
  hStdError:=writehandle;
 end;
 s_env:=
  #0'DOCUMENT_ROOT='+reslash(pconfig(ss.config)^.diskroot)+
  #0'GATEWAY_INTERFACE=CGI/1.1'+
  #0'QUERY_STRING='+ss.qs+
  #0'REMOTE_ADDR='+getremoteip(ss.s)+
  #0'REMOTE_PORT='+strl(getremoteport(ss.s))+
  #0'REQUEST_METHOD='+ss.method+
  #0'REQUEST_URI='+ss.url+
  #0'SCRIPT_NAME=/'+reslash(ss.filename)+
  #0'SCRIPT_FILENAME='+reslash(filename)+
  #0'SERVER_NAME='+ss.host+
  #0'SERVER_PORT='+strl(server_port)+
  #0'SERVER_PROTOCOL='+ss.proto+
  #0'SERVER_SOFTWARE='+cgi_apptitle
{tohle je tu kvuli novemu PHP}
  +#0'REDIRECT_STATUS=200'
  ;
 if ss.verified then begin
  s_env:=s_env+
  #0'AUTH_TYPE=Basic'+
  #0'REMOTE_USER='+ss.verified_user
  ;
 end;
 s_env:=s_env+allheaders(ss);
 en:=getenvironmentstrings;
 hp:=en;
 while hp^<>#0 do begin
  q:=hp;
  inc(hp,length(q));
  if q[1]<>'=' then if pos(#0+q,s_env)=0 then begin
   insert(#0+q,s_env,length(s_env)+1);
  end;
  inc(hp);
 end;
 freeenvironmentstrings(en);
 s_env:=s_env+#0#0;
 env:=@s_env[2];
 if length(cdir)=0 then ccdir:=nil else ccdir:=pchar(cdir);
 if not(CreateProcess(nil,PChar(CommandLine),nil,nil,true,CREATE_NO_WINDOW,env,ccdir,StartupInfo,ProcessInfo)) then begin
  errmsg;
  exit;
 end;
 CloseHandle(ProcessInfo.hThread);
 CloseHandle(WriteHandle);
 CloseHandle(stdinHandle);
 result2:=posthandle;
 result:=readhandle;
end;

procedure stopexec(readhandle:thandle;var ProcessInfo:TProcessInformation);
begin
 CloseHandle(ProcessInfo.hProcess);
 CloseHandle(ReadHandle);
end;

procedure exec_con(var ss:send_struct;exename:ansistring;exeparam:ansistring;nph:boolean);
var
 r,r2:thandle;
 pi:TProcessInformation;
 ec:integer;
 resp,q:ansistring;
 i,j,r_in:integer;
const
 r_buf=1024;

{po odeslani dat bude handle uzavren}
procedure send_stdin(var ss:send_struct;h:thandle;inbytes:integer);
var
 rfds:fd_set;
 tm:timeval;
 written,i,q,start:integer;
begin
 written:=0;
 if ss.req_extra>0 then begin
  writefile(h,ss.req[length(ss.req)-ss.req_extra+1],ss.req_extra,i,nil);
  inc(written,ss.req_extra);
 end;
 if written>=inbytes then begin
  closehandle(h);
  exit;
 end;
 start:=gettickcount;
 rfds.fd_count:=1;
 rfds.fd_array[0]:=ss.s;
 tm.tv_sec:=posthead_timeout div 1000;
 tm.tv_usec:=0;
 ss.by:=0;
 while written<inbytes do begin
  select(0,@rfds,nil,nil,@tm);
  i:=recv(ss.s,@(ss.b^[1]),max_request,0);
  if i=0 then break;
  if i=u_val(SOCKET_ERROR) then begin
   inc(sockerrors);
   closehandle(h);
   thread_exit(ss);
   exitthread(0);
  end;
  if not(writefile(h,(ss.b^[1]),i,q,nil)) then break;
  inc(written,q);
  in_stat(i);
  if (gettickcount>(posthead_timeout+start)) then break;
 end;
 closehandle(h);
end;

var
 filename,directory:string;
begin
 {todo: starttimer(killproc(struct(@pi,@getcurrentthread),sometimeout))
 killproc: kill process+thread}
 directory:=getdirectory(exename);
 filename:=exename;
 if pactdef(ss.adef)^.param<>'' then begin {spusteni pres interpret}
  exename:=getfile(exename);
  exeparam:='"'+exename+'" '+exeparam;
  exename:=pactdef(ss.adef)^.param;
 end;
 {todo: sezrat stderr a pokud na nej neco prijde tak error. Zatim
  je stderr>stdout. Ve win32 se to zda bez vytvoreni dalsiho threadu
  celkem nemozne}
 r_in:=ival(getheader(ss,'content-length'),0);
 r:=startexec(ss,filename,exename,exeparam,pi,q,r_in>0,r2,directory);
 if r=invalid_handle_value then begin
  send_error(ss,500,'Cannot execute program','Error executing program: '+q);
 end else begin
  if r_in>0 then begin
   if r2=invalid_handle_value then begin
    send_error(ss,500,'Cannot execute program','Error opening STDIN');
    stopexec(r,pi);
    exit;
   end;
   send_stdin(ss,r2,r_in);
   {todo: delat to synchronne, cili dovolit nejdriv neco poslat a pak prijmout data
          bohuzel to ve windows je skoro nemozne bez vytvareni noveho threadu}
  end;
  ss.h:=r;{handle se predava ve strukture}
  ec:=ss.errorcode;
  if ec=0 then ec:=200;
  if not(nph) then begin
   q:='';
   resp:='';
   r_in:=0;
   repeat
    setlength(resp,length(resp)+r_buf);
    readfile(ss.h,resp[r_in+1],r_buf,i,nil);
    r_in:=r_in+i;
    setlength(resp,r_in);
    j:=checkcrlf(@resp[1],length(resp));
    if j>0 then begin
     q:=copy(resp,j,$7fffffff);
     setlength(resp,j-1);
     break;
    end;
    if i=0 then begin
     send_error(ss,500,'No header received','Error executing program');
     stopexec(r,pi);
     exit;
    end;
   until false;
   while length(resp)>0 do begin
    if resp[length(resp)] in [#10,#13] then setlength(resp,length(resp)-1) else break;
   end;
   if getheader2(resp,'location')<>'' then ec:=302;
   if (length(resp)=0) or (resp[1] in ['0'..'9']) then begin
    directory:='';
    i:=1;
    while (i<=length(resp)) and (resp[i] in ['0'..'9']) do begin
     directory:=directory+resp[i];
     inc(i);
    end;
    val(directory,ec,i);
    resp:='HTTP/1.0 '+resp;
   end;
   if not(matchq(resp,'http/?.? ')) then resp:='HTTP/1.0 '+strl(ec)+' W'#13#10+resp;
   if getheader2(resp,'content-type')='' then resp:=resp+#13#10'Content-type: '+getmimefromfile(ss,exename);
   ss.contentlen:=ival(getheader2(resp,'content-length'),0);
   resp:=resp+crlf+crlf+q;
   ss.errorcode:=ec;
   write_alog(ss);
   send_bstring(ss,resp);
  end;
  flush_buffer(ss);
  write_alog(ss);
  send_handle(ss,false,1);
 end;
 stopexec(r,pi);
end;
