{$define mod_proxy}
{Umozni proxy pristup na pocitac (ftp, http, https, connect proxy)}

procedure http_proxy(var ss:send_struct;mode:integer);
var
 err,c,bsindex,r:integer;
 f:boolean;
 oout,out,rem,host:ansistring;
 olds,news:SOCKET;
 port:word;
begin
 ss.proxy:=true;
 if mode=1 then begin {CONNECT rerquest}
  c:=1;
  port:=80;
  bsindex:=pos(':',ss.url);
  if bsindex>0 then begin
   val(copy(ss.url,bsindex+1,$7fffffff),port,r);
   if r<>0 then port:=80;
   host:=copy(ss.url,1,bsindex-1);
  end else host:=ss.url;
  while getline(ss.req,c,out) do begin end;
  oout:=copy(ss.req,c,$7fffffff);
  news:=open_sock(host,port,err);
 end else begin
  c:=1;
  f:=true;
  port:=80;
  oout:='';
  while getline(ss.req,c,out) do begin
   if (f) then begin
    rem:=copy(ss.url,8,$7fffffff);
    bsindex:=pos('/',rem);
    if bsindex=0 then bsindex:=$7fffffff;
    host:=copy(rem,1,bsindex-1);
    if bsindex=$7fffffff then rem:='/' else rem:=copy(rem,bsindex,$7fffffff);
    bsindex:=pos(':',host);
    if bsindex>0 then begin
     val(copy(host,bsindex+1,$7fffffff),port,r);
     if r<>0 then port:=80;
     host:=copy(host,1,bsindex-1);
    end;
    out:=ss.method+' '+rem+' '+copy(out,length(ss.method)+length(ss.url)+2,$7fffffff);
    f:=false;
   end;
   if beginwithi(out,'Proxy-') then begin
    out:=copy(out,7,$7fffffff);
   end;
   oout:=oout+out+#13#10;
  end;
  oout:=oout+#13#10;
  oout:=oout+copy(ss.req,c,$7fffffff);
  news:=open_sock(host,port,err);
 end;
 if news=INVALID_SOCKET then begin
 case err of
   -1:begin
     send_error(ss,400,'Host not found','Host not found: '+htmlchar(host)+':'+strl(port));
    end;
   10061:begin
     send_error(ss,400,'Connection refused','Connection refused when connecting to '+htmlchar(host)+':'+strl(port));
   end;
   else begin
     send_error(ss,400,'Connection error','Error '+strl(err)+' when connecting to '+htmlchar(host)+':'+strl(port));
   end;
  end;
  exit;
 end;
 olds:=ss.s;
 ss.s:=news;
 send_bstring(ss,oout);
 flush_buffer(ss);
 startsockpipe(olds,news);
 ss.s:=invalid_socket;{pipe to zavre}
 thread_exit(ss);
 exitthread(0);
end;

type
 tinternetopen=function(a:pointer;b:dword;c:pointer;d:pointer;e:dword):hinternet;stdcall;
 tinternetopenurl=function(a:hinternet;b:pchar;c:pchar;d:dword;e:dword;f:dword):hinternet;stdcall;
 tinternetreadfile=function(a:hinternet;b:pointer;c:dword;var d:integer):bool;stdcall;
 tinternetclosehandle=function(a:hinternet):bool;stdcall;
var
 internetopen:tinternetopen;
 internetopenurl:tinternetopenurl;
 internetreadfile:tinternetreadfile;
 internetclosehandle:tinternetclosehandle;
 wininet:handle;

procedure initwininet;
begin
 wininet:=loadlibrary('wininet.dll');
 if wininet<>0 then begin
  internetclosehandle:=getprocaddress(wininet,'InternetCloseHandle');
  if @internetclosehandle=nil then exit;
  internetreadfile:=getprocaddress(wininet,'InternetReadFile');
  if @internetreadfile=nil then exit;
  internetopenurl:=getprocaddress(wininet,'InternetOpenUrlA');
  if @internetopenurl=nil then exit;
  internetopen:=getprocaddress(wininet,'InternetOpenA');
  if @internetopen=nil then exit;
 end;
end;

procedure ms_proxy(var ss:send_struct);
var
 net,ur:hinternet;
 i:integer;
 nb:p0;
 mime:ansistring;
begin
 if @internetopen=nil then initwininet;
 if @internetopen=nil then begin
  send_error(ss,404,'Proxy error','wininet.dll not available or corrupted');
  exit;
 end;
 net:=InternetOpen(nil,0,nil,nil,0);
 if (longint(net)=0) then begin
  i:=getlasterror;
  send_error(ss,404,'Proxy error','Error '+strl(i)+' when fetching '+htmlchar(ss.url));
  exit;
 end;
 ur:=internetopenurl(net,pchar(ss.url),nil,0,$0400F000,0);{no-cache}
 if (longint(ur)=0) then begin
  i:=getlasterror;
  send_error(ss,404,'Proxy error','Error '+strl(i)+' when fetching '+htmlchar(ss.url));
  exit;
 end;
 mime:=getmimefromfile({$ifdef mod_conf}ss,{$endif}ss.url);
 if length(ss.url)=0 then mime:='text/html' else if ss.url[length(ss.url)]='/' then mime:='text/html';
 send_simpleheader(ss,200,mime,-1);
 getmem(nb,ms_proxy_buffer);
 repeat
  internetreadfile(ur,nb,ms_proxy_buffer,i);
  send_buffer(ss,nb^,i);
 until i=0;
 freemem(nb,ms_proxy_buffer);
 internetclosehandle(ur);
 internetclosehandle(net);
end;
