{$A-,B-,D+,F-,G+,I-,K-,L+,N-,P-,Q-,R-,S-,T-,V-,W-,X+,Y+}
{$ifdef win32}{$H-,J+,O+}{$endif}
{$ifdef ver140}{$WARN SYMBOL_PLATFORM OFF}{$endif}
unit winsock;
{
 Written by Bilbo (22.9.1999)
 Email: bilbo@centrum.cz
 this is ported from winsock.h and it has some extra features (definition
 of IP and ICMP headers, corrected one protocol typo in winsock.h, some
 extra constants added...)
 Use this absolutely freely, even for commercial purposes.
 But if you improve it someway, please send it back to me (by email).
 Works ok in Borland Pascal 7.0, maybe in TPW (untested)
 Now porting to win32 (delphi 2.0 - not complete, still crashing)
}
interface
{$ifndef win32}
uses winprocs,wintypes;
{$else}
uses windows;
{$endif}
type
 DWORD=longint;
 u_char=byte;
 pu_char=^u_char;
 u_short=word;
 pu_short=^u_short;
 {$ifdef win32}
 u_int=dword;
 short=smallint;
 {$else}
 short=integer;
 u_int=word;
 {$endif}
 u_long=longint;
 long=longint;
 int=integer;
 pu_long=^u_long;
 PINT=^int;
 BOOL=int;
 SOCKET=u_int;
 tsocket=socket;
 HANDLE=tHandle;
 ppchar=^pchar;
 pstring=^string;
 pinteger=^integer;
 LPSTR=pchar;
 PSTR=pchar;
const
 SD_RECEIVE      =0;
 SD_SEND         =1;
 SD_BOTH         =2;

 {$ifdef win32}
 wsd='wsock32.dll';
 {$else}
 wsd='WINSOCK';
 {$endif}
 FD_SETSIZE=64;
 WSADESCRIPTION_LEN=256;
 WSASYS_STATUS_LEN=128;

 {All Windows Sockets error constants are biased by WSABASEERR from "normal"}
 WSABASEERR              =10000;

 {Windows Sockets definitions of regular Microsoft C error constants}
 WSAEINTR                =WSABASEERR+4;
 WSAEBADF                =WSABASEERR+9;
 WSAEACCES               =WSABASEERR+13;
 WSAEFAULT               =WSABASEERR+14;
 WSAEINVAL               =WSABASEERR+22;
 WSAEMFILE               =WSABASEERR+24;

 {Windows Sockets definitions of regular Berkeley error constants}
 WSAEWOULDBLOCK          =WSABASEERR+35;
 WSAEINPROGRESS          =WSABASEERR+36;
 WSAEALREADY             =WSABASEERR+37;
 WSAENOTSOCK             =WSABASEERR+38;
 WSAEDESTADDRREQ         =WSABASEERR+39;
 WSAEMSGSIZE             =WSABASEERR+40;
 WSAEPROTOTYPE           =WSABASEERR+41;
 WSAENOPROTOOPT          =WSABASEERR+42;
 WSAEPROTONOSUPPORT      =WSABASEERR+43;
 WSAESOCKTNOSUPPORT      =WSABASEERR+44;
 WSAEOPNOTSUPP           =WSABASEERR+45;
 WSAEPFNOSUPPORT         =WSABASEERR+46;
 WSAEAFNOSUPPORT         =WSABASEERR+47;
 WSAEADDRINUSE           =WSABASEERR+48;
 WSAEADDRNOTAVAIL        =WSABASEERR+49;
 WSAENETDOWN             =WSABASEERR+50;
 WSAENETUNREACH          =WSABASEERR+51;
 WSAENETRESET            =WSABASEERR+52;
 WSAECONNABORTED         =WSABASEERR+53;
 WSAECONNRESET           =WSABASEERR+54;
 WSAENOBUFS              =WSABASEERR+55;
 WSAEISCONN              =WSABASEERR+56;
 WSAENOTCONN             =WSABASEERR+57;
 WSAESHUTDOWN            =WSABASEERR+58;
 WSAETOOMANYREFS         =WSABASEERR+59;
 WSAETIMEDOUT            =WSABASEERR+60;
 WSAECONNREFUSED         =WSABASEERR+61;
 WSAELOOP                =WSABASEERR+62;
 WSAENAMETOOLONG         =WSABASEERR+63;
 WSAEHOSTDOWN            =WSABASEERR+64;
 WSAEHOSTUNREACH         =WSABASEERR+65;
 WSAENOTEMPTY            =WSABASEERR+66;
 WSAEPROCLIM             =WSABASEERR+67;
 WSAEUSERS               =WSABASEERR+68;
 WSAEDQUOT               =WSABASEERR+69;
 WSAESTALE               =WSABASEERR+70;
 WSAEREMOTE              =WSABASEERR+71;

 {Extended Windows Sockets error constant definitions}
 WSASYSNOTREADY          =WSABASEERR+91;{WSAStartup - net subsystem unusable}
 WSAVERNOTSUPPORTED      =WSABASEERR+92;{WSAStartup - Win Sockets version not supported}
 WSANOTINITIALISED       =WSABASEERR+93;{WSAStartup has not been performed}

 WSAEDISCON              =WSABASEERR+101;

 {New Winsock 2 errors from winsock2.h}
 WSAENOMORE              =WSABASEERR+102;
 WSAECANCELLED           =WSABASEERR+103;
 WSAEINVALIDPROCTABLE    =WSABASEERR+104;
 WSAEINVALIDPROVIDER     =WSABASEERR+105;
 WSAEPROVIDERFAILEDINIT  =WSABASEERR+106;
 WSASYSCALLFAILURE       =WSABASEERR+107;
 WSASERVICE_NOT_FOUND    =WSABASEERR+108;
 WSATYPE_NOT_FOUND       =WSABASEERR+109;
 WSA_E_NO_MORE           =WSABASEERR+110;
 WSA_E_CANCELLED         =WSABASEERR+111;
 WSAEREFUSED             =WSABASEERR+112;

 {Windows Sockets errors redefined as regular Berkeley error constants}
 EWOULDBLOCK             =WSAEWOULDBLOCK;
 EINPROGRESS             =WSAEINPROGRESS;
 EALREADY                =WSAEALREADY;
 ENOTSOCK                =WSAENOTSOCK;
 EDESTADDRREQ            =WSAEDESTADDRREQ;
 EMSGSIZE                =WSAEMSGSIZE;
 EPROTOTYPE              =WSAEPROTOTYPE;
 ENOPROTOOPT             =WSAENOPROTOOPT;
 EPROTONOSUPPORT         =WSAEPROTONOSUPPORT;
 ESOCKTNOSUPPORT         =WSAESOCKTNOSUPPORT;
 EOPNOTSUPP              =WSAEOPNOTSUPP;
 EPFNOSUPPORT            =WSAEPFNOSUPPORT;
 EAFNOSUPPORT            =WSAEAFNOSUPPORT;
 EADDRINUSE              =WSAEADDRINUSE;
 EADDRNOTAVAIL           =WSAEADDRNOTAVAIL;
 ENETDOWN                =WSAENETDOWN;
 ENETUNREACH             =WSAENETUNREACH;
 ENETRESET               =WSAENETRESET;
 ECONNABORTED            =WSAECONNABORTED;
 ECONNRESET              =WSAECONNRESET;
 ENOBUFS                 =WSAENOBUFS;
 EISCONN                 =WSAEISCONN;
 ENOTCONN                =WSAENOTCONN;
 ESHUTDOWN               =WSAESHUTDOWN;
 ETOOMANYREFS            =WSAETOOMANYREFS;
 ETIMEDOUT               =WSAETIMEDOUT;
 ECONNREFUSED            =WSAECONNREFUSED;
 ELOOP                   =WSAELOOP;
 ENAMETOOLONG            =WSAENAMETOOLONG;
 EHOSTDOWN               =WSAEHOSTDOWN;
 EHOSTUNREACH            =WSAEHOSTUNREACH;
 ENOTEMPTY               =WSAENOTEMPTY;
 EPROCLIM                =WSAEPROCLIM;
 EUSERS                  =WSAEUSERS;
 EDQUOT                  =WSAEDQUOT;
 ESTALE                  =WSAESTALE;
 EREMOTE                 =WSAEREMOTE;

 {Authoritative Answer: Host not found}
 WSAHOST_NOT_FOUND       =WSABASEERR+1001;
 HOST_NOT_FOUND          =WSAHOST_NOT_FOUND;

 {Non-Authoritative: Host not found, or SERVERFAIL}
 WSATRY_AGAIN            =WSABASEERR+1002;
 TRY_AGAIN               =WSATRY_AGAIN;

 {Non recoverable errors, FORMERR, REFUSED, NOTIMP}
 WSANO_RECOVERY          =WSABASEERR+1003;
 NO_RECOVERY             =WSANO_RECOVERY;

 {Valid name, no data record of requested type}
 WSANO_DATA              =WSABASEERR+1004;
 NO_DATA                 =WSANO_DATA;

 {no address, look for MX record}
 WSANO_ADDRESS           =WSANO_DATA;
 NO_ADDRESS              =WSANO_ADDRESS;

 {Constants and structures defined by the internet system,
  Per RFC 790, September 1981}
 {Protocols}

 IPPROTO_IP              =0;               { dummy for IP }
 IPPROTO_ICMP            =1;               { control message protocol }
 IPPROTO_IGMP            =2;
 IPPROTO_GGP             =3;               { gateway^2 (deprecated) }
 IPPROTO_IPIP            =4;               {!IPIP tunnels, probably unsupported}
 IPPROTO_TCP             =6;               { tcp }
 IPPROTO_EGP             =8;               {!Exterior Gateway protocol, probably unsupported }
 IPPROTO_PUP             =12;              { pup }
 IPPROTO_UDP             =17;              { user datagram protocol }
 IPPROTO_IDP             =22;              { xns idp }
 IPPROTO_ND              =77;              { UNOFFICIAL net disk proto }

 IPPROTO_RAW             =255;             { raw IP packet }
 IPPROTO_MAX             =256;

 {Port/socket numbers: network standard functions}
 IPPORT_ECHO             =7;            {Echo service}
 IPPORT_DISCARD          =9;            {Discard transmissions service}
 IPPORT_SYSTAT           =11;           {System status service}
 IPPORT_DAYTIME          =13;           {Time of day service}
 IPPORT_NETSTAT          =15;           {Network status service}
 IPPORT_FTP              =21;           {File Transfer Protocol}
 IPPORT_TELNET           =23;           {Telnet protocol}
 IPPORT_SMTP             =25;           {Simple Mail Transfer Protocol}
 IPPORT_TIMESERVER       =37;           {Timeserver service}
 IPPORT_NAMESERVER       =42;           {Domain Name Service}
 IPPORT_WHOIS            =43;           {Internet Whois service}
 IPPORT_MTP              =57;

 {Port/socket numbers: host specific functions}
 IPPORT_TFTP             =69;           {Trivial File Transfer Protocol}
 IPPORT_RJE              =77;
 IPPORT_FINGER           =79;           {Finger service}
 IPPORT_TTYLINK          =87;
 IPPORT_SUPDUP           =95;           {SUPDUP protocol}

 {UNIX TCP sockets}
 IPPORT_EXECSERVER       =512;          {execd service}
 IPPORT_LOGINSERVER      =513;          {rlogind service}
 IPPORT_CMDSERVER        =514;
 IPPORT_EFSSERVER        =520;

 {UNIX UDP sockets}
 IPPORT_BIFFUDP          =512;
 IPPORT_WHOSERVER        =513;
 IPPORT_ROUTESERVER      =520;{520+1 also used}

 {Ports < IPPORT_RESERVED are reserved for privileged processes (e.g. root).}
 IPPORT_RESERVED         =1024;

 {Ports greater this value are reserved for (non-privileged) servers.}
 IPPORT_USERRESERVED     =5000;

 {Link numbers}
 IMPLINK_IP              =155;
 IMPLINK_LOWEXPER        =156;
 IMPLINK_HIGHEXPER       =158;

 {Types}
 SOCK_STREAM     =1;               { stream socket }
 SOCK_DGRAM      =2;               { datagram socket }
 SOCK_RAW        =3;               { raw-protocol interface }
 SOCK_RDM        =4;               { reliably-delivered message }
 SOCK_SEQPACKET  =5;               { sequenced packet stream }

 {Option flags per-socket}
 SO_DEBUG        =$0001;          { turn on debugging info recording }
 SO_ACCEPTCONN   =$0002;          { socket has had listen() }
 SO_REUSEADDR    =$0004;          { allow local address reuse }
 SO_KEEPALIVE    =$0008;          { keep connections alive }
 SO_DONTROUTE    =$0010;          { just use interface addresses }
 SO_BROADCAST    =$0020;          { permit sending of broadcast msgs }
 SO_USELOOPBACK  =$0040;          { bypass hardware when possible }
 SO_LINGER       =$0080;          { linger on close if data present }
 SO_OOBINLINE    =$0100;          { leave received OOB data in line }

 SO_DONTLINGER   =u_int(NOT(SO_LINGER));

 {Additional options}
 SO_SNDBUF       =$1001;         { send buffer size }
 SO_RCVBUF       =$1002;         { receive buffer size }
 SO_SNDLOWAT     =$1003;         { send low-water mark }
 SO_RCVLOWAT     =$1004;         { receive low-water mark }
 SO_SNDTIMEO     =$1005;         { send timeout }
 SO_RCVTIMEO     =$1006;         { receive timeout }
 SO_ERROR        =$1007;         { get error status and clear }
 SO_TYPE         =$1008;         { get socket type }

 {Options for connect and disconnect data and options.  Used only by
  non-TCP/IP transports such as DECNet, OSI TP4, etc.}
 {May be unsupported, not from winsock.h}
 SO_CONNDATA     =$7000;
 SO_CONNOPT      =$7001;
 SO_DISCDATA     =$7002;
 SO_DISCOPT      =$7003;
 SO_CONNDATALEN  =$7004;
 SO_CONNOPTLEN   =$7005;
 SO_DISCDATALEN  =$7006;
 SO_DISCOPTLEN   =$7007;

 { Option for opening sockets for synchronous access. }
 SO_OPENTYPE     =$7008;
 SO_SYNCHRONOUS_ALERT   =$10;
 SO_SYNCHRONOUS_NONALERT=$20;

 { Other NT-specific options.}
 SO_MAXDG        =$7009;
 SO_MAXPATHDG    =$700A;
 SO_UPDATE_ACCEPT_CONTEXT =$700B;
 SO_CONNECT_TIME =$700C;

 {TCP options}
 TCP_NODELAY     =$0001;
 TCP_BSDURGENT   =$7000;

 {Address families}
 AF_UNSPEC       =0;              { unspecified }
 AF_UNIX         =1;              { local to host (pipes, portals) }
 AF_INET         =2;              { internetwork: UDP, TCP, etc. }
 AF_IMPLINK      =3;              { arpanet imp addresses }
 AF_PUP          =4;              { pup protocols: e.g. BSP }
 AF_CHAOS        =5;              { mit CHAOS protocols }
 AF_NS           =6;              { XEROX NS protocols }
 AF_IPX          =AF_NS;          { IPX Protocols: IPX, SPX, etc... }
 AF_ISO          =7;              { ISO protocols }
 AF_OSI          =AF_ISO;         { OSI is ISO }
 AF_ECMA         =8;              { european computer manufacturers }
 AF_DATAKIT      =9;              { datakit protocols }
 AF_CCITT        =10;             { CCITT protocols, X.25 etc }
 AF_SNA          =11;             { IBM SNA }
 AF_DECnet       =12;             { DECnet }
 AF_DLI          =13;             { Direct data link interface }
 AF_LAT          =14;             { LAT }
 AF_HYLINK       =15;             { NSC Hyperchannel }
 AF_APPLETALK    =16;             { AppleTalk }
 AF_NETBIOS      =17;             { NetBios-style addresses }
 AF_VOICEVIEW    =18;             { VoiceView }
 AF_FIREFOX      =19;             { FireFox }
 AF_UNKNOWN1     =20;             { Somebody is using this! }
 AF_BAN          =21;             { Banyan }

 AF_MAX          =22;

 AF_NBS          =7;            { from winsock.inc - ????}

 {Protocol families, same as address families for now.}
 PF_UNSPEC       =AF_UNSPEC;
 PF_UNIX         =AF_UNIX;
 PF_INET         =AF_INET;
 PF_IMPLINK      =AF_IMPLINK;
 PF_PUP          =AF_PUP;
 PF_CHAOS        =AF_CHAOS;
 PF_NS           =AF_NS;
 PF_ISO          =AF_ISO;
 PF_OSI          =AF_OSI;
 PF_ECMA         =AF_ECMA;
 PF_DATAKIT      =AF_DATAKIT;
 PF_CCITT        =AF_CCITT;
 PF_SNA          =AF_SNA;
 PF_DECnet       =AF_DECnet;
 PF_DLI          =AF_DLI;
 PF_LAT          =AF_LAT;
 PF_HYLINK       =AF_HYLINK;
 PF_APPLETALK    =AF_APPLETALK;
 PF_VOICEVIEW    =AF_VOICEVIEW;
 PF_FIREFOX      =AF_FIREFOX;
 PF_UNKNOWN1     =AF_UNKNOWN1;
 PF_BAN          =AF_BAN;

 PF_MAX          =AF_MAX;

 PF_NBS          =AF_NBS;       { from winsock.inc - ????}

 {Level number for (get/set)sockopt() to apply to socket itself.}
 SOL_SOCKET      =$ffff;           { options for socket level }

 {Maximum queue length specifiable by listen.}
 SOMAXCONN       =5;

 MSG_OOB         =$1;             { process out-of-band data }
 MSG_PEEK        =$2;             { peek at incoming message }
 MSG_DONTROUTE   =$4;             { send without using routing tables }

 MSG_MAXIOVLEN   =16;
 MSG_PARTIAL     =$8000;          { partial send or recv for message xport }

 {Define constant based on rfc883, used by gethostbyxxxx() calls.}
 MAXGETHOSTSTRUCT        =1024;

 MAXHOSTNAME             =128;   {Maximum length of a DNS hostname}
 MAXADDRSTR              =16;    {Maximum length of an IP Address string}

 {Define flags to be used with the WSAAsyncSelect() call.}
 FD_READ         =$01;
 FD_WRITE        =$02;
 FD_OOB          =$04;
 FD_ACCEPT       =$08;
 FD_CONNECT      =$10;
 FD_CLOSE        =$20;

 IN_CLASSA_NET           =$ff000000;
 IN_CLASSA_NSHIFT        =24;
 IN_CLASSA_HOST          =$00ffffff;
 IN_CLASSA_MAX           =128;

 IN_CLASSB_NET           =$ffff0000;
 IN_CLASSB_NSHIFT        =16;
 IN_CLASSB_HOST          =$0000ffff;
 IN_CLASSB_MAX           =65536;

 IN_CLASSC_NET           =$ffffff00;
 IN_CLASSC_NSHIFT        =8;
 IN_CLASSC_HOST          =$000000ff;

 INADDR_ANY              =u_long($00000000);
 INADDR_LOOPBACK         =u_long($7f000001);
 INADDR_BROADCAST        =u_long($ffffffff);
 INADDR_NONE             =u_long($ffffffff);

 {Defines for Multicast INADDR}
 INADDR_UNSPEC_GROUP     =$e0000000; { 224.0.0.0   }
 INADDR_ALLHOSTS_GROUP   =$e0000001; { 224.0.0.1   }
 INADDR_MAX_LOCAL_GROUP  =$e00000ff; { 224.0.0.255 }

 IN_LOOPBACKNET          =127;

 {Define constants based on rfc883}
 PACKETSZ        =512;             { maximum packet size }
 MAXDNAME        =256;             { maximum domain name }
 MAXCDNAME       =255;             { maximum compressed domain name }
 MAXLABEL        =63;              { maximum length of domain label }
 HFIXEDSZ        =12;              { #/bytes of fixed data in header }
 QFIXEDSZ        =4;               { #/bytes of fixed data in query }
 RRFIXEDSZ       =10;              { #/bytes of fixed data in r record }
 INT32SZ         =4;               { for systems without 32-bit ints }
 INT16SZ         =2;               { for systems without 16-bit ints }
 INADDRSZ        =4;               { for sizeof(struct inaddr) != 4 }

 {Currently defined opcodes}
 QUERY          =$0;            { standard query }
 IQUERY         =$1;            { inverse query }
 STATUS         =$2;            { nameserver status query }
 {xxx           =$3;           }{ 0x3 reserved }
 NS_NOTIFY_OP   =$4;            { notify secondary of SOA change }
 { non standard - supports ALLOW_UPDATES stuff from Mike Schwartz }
 UPDATEA        =$9;            { add resource record }
 UPDATED        =$a;            { delete a specific resource record }
 UPDATEDA       =$b;            { delete all named resource record }
 UPDATEM        =$c;            { modify a specific resource record }
 UPDATEMA       =$d;            { modify all named resource record }
 ZONEINIT       =$e;            { initial zone transfer }
 ZONEREF        =$f;            { incremental zone referesh }

 {Currently defined response codes}
 NOERROR        =$0;            { no error }
 FORMERR        =$1;            { format error }
 SERVFAIL       =$2;            { server failure }
 NXDOMAIN       =$3;            { non existent domain }
 NOTIMP         =$4;            { not implemented }
 REFUSED        =$5;            { query refused }
 NOCHANGE       =$f;            {!non standard - update failed to change db }

 {Defines for handling compressed domain names}
 INDIR_MASK     =$c0;

 {Internet nameserver port number}
 NAMESERVER_PORT =53;

 IP_TTL	        =4;	{ level=IPPROTO_IP option, Time To Live }
 MAX_TTL	=255;	{ maximum IP "Time To Live" value }

 {ICMP types}
 ICMP_ECHOREPLY	=0;	{ICMP type: echo reply}
 ICMP_ECHOREQ	=8;	{ICMP type: echo request}

 {Options for use with [gs]etsockopt at the IP level.}
 IP_OPTIONS      =1;               {set/get IP per-packet options}

 { This is used instead of -1, since the
   SOCKET type is unsigned.}
 INVALID_SOCKET   =SOCKET(not 0);
 SOCKET_ERROR           =(-1);

 {Commands for ioctlsocket(),  taken from the BSD file fcntl.h.
  Ioctl's have the command encoded in the lower word,
  and the size of any in or out parameters in the upper
  word.  The high 2 bits of the upper word are used
  to encode the in/out status of the parameter; for now
  we restrict parameters to at most 128 bytes.}
 IOCPARM_MASK    =$7f;            { parameters must be < 128 bytes }
 IOC_VOID        =$20000000;      { no parameters }
 IOC_OUT         =$40000000;      { copy out parameters }
 IOC_IN          =$80000000;      { copy in parameters }
 IOC_INOUT       =(IOC_IN or IOC_OUT);  { 0x20000000 distinguishes new & old ioctl's }

type
 fd_set=packed record
         fd_count:u_int;
         fd_array:array[0..FD_SETSIZE-1] of SOCKET;
        end;
 WSAData=packed record
         wVersion:word;
         wHighVersion:word;
         szDescription:array[0..WSADESCRIPTION_LEN] of char;
         szSystemStatus:array[0..WSASYS_STATUS_LEN] of char;
         iMaxSockets:u_short;
         iMaxUdpDg:u_short;
         lpVendorInfo:pchar;
        end;
 TWsaData=WSAData;
 LPWSADATA=^WSAData;
 PWSADATA=^WSAData;

 {Structures returned by network data base library, taken from the
  BSD file netdb.h.  All addresses are supplied in host order, and
  returned in network order (suitable for use in system calls).}

 hostent=packed record
          h_name:pchar;       {official name of host}
          h_aliases:ppchar;   {alias list}
          h_addrtype:short;   {host address type}
          h_length:short;     {length of address}
          h_addr_list:ppchar; {list of addresses}
         end;
 {It is assumed here that a network number
  fits in 32 bits.}
 netent=packed record
         n_name:pchar;        {official name of net}
         n_aliases:ppchar;    {alias list}
         n_addrtype:short;    {net address type}
         n_net:u_long;        {network #}
        end;

 servent=packed record
          s_name:pchar;       {official service name}
          s_aliases:ppchar;   {alias list}
          s_port:short;       {port #}
          s_proto:pchar;      {protocol to use}
         end;

 protoent=packed record
           p_name:pchar;      {official protocol name}
           p_aliases:ppchar;  {alias list}
           p_proto:short;     {protocol #}
          end;

 {Structure used in select() call, taken from the BSD file sys/time.h.}
 timeval=packed record
          tv_sec:long;         {seconds}
          tv_usec:long;        {and microseconds}
         end;

 {Internet address (old style... should be updated)}
 in_addr=packed record
         case integer of
          0:(s_b1,s_b2,s_b3,s_b4:u_char);
          1:(s_w1,s_w2:u_short);
          2:(S_addr:u_long);
          3:(s_net,s_host,s_lh,s_impno:u_char);{nonstandard}
          4:(s_net_host,s_imp:u_short);{nonstandard}
         end;
 S_un=in_addr;

 {Socket address, internet style.}
 sockaddr_in=packed record
              sin_family:short;
              sin_port:u_short;
              sin_addr:in_addr;
              sin_zero:array[0..7] of char;
             end;
 {Structure used by kernel to store most addresses.}
 sockaddr=packed record
           sa_family:u_short;              {address family}
           sa_data:array[0..13] of char;   {up to 14 bytes of direct address}
          end;
 {Structure used by kernel to pass protocol information in raw sockets.}
 sockproto=packed record
            sp_family:u_short;            {address family}
            sp_protocol:u_short;          {protocol}
           end;

 {Structure used for manipulating linger option.}
 linger=packed record
         l_onoff:u_short;                 {option on/off}
         l_linger:u_short;                {linger time}
        end;

 {Microsoft Windows Extended data types}
 PSOCKADDR=^sockaddr;
 LPSOCKADDR=^sockaddr;

 PSOCKADDR_IN=^sockaddr_in;
 LPSOCKADDR_IN=^sockaddr_in;

 PLINGER=^linger;
 LPLINGER=^linger;

 PIN_ADDR=^in_addr;
 LPIN_ADDR=^in_addr;

 PFD_SET=^fd_set;
 LPFD_SET=^fd_set;

 PHOSTENT=^hostent;
 LPHOSTENT=^hostent;

 PSERVENT=^servent;
 LPSERVENT=^servent;

 PPROTOENT=^protoent;
 LPPROTOENT=^protoent;

 PTIMEVAL=^timeval;
 LPTIMEVAL=^timeval;

 PROC=procedure;
 FARPROC=^PROC; {to far WINAPI procedure ... need to modify}

 {definition of ICMP header as per RFC 792}
 icmp_hdr=packed record
        icmp_type:u_char;	{ type of message }
	code:u_char;		{ type sub code }
	checksum:u_short;	{ ones complement cksum }
	id:u_short;		{ identifier }
	seq:u_short;		{ sequence number }
	data:array[0..0]of char;{ data }
 end;
 PICMPHDR=^icmp_hdr;
 LPICMPHDR=^icmp_hdr;

{ definition of IP header version 4 as per RFC 791 }
 ip_hdr=packed record
	VIHL:u_char;		{ header length (4 bits) / version info (4 bits)}
	tos:u_char;		{ type of service }
	totlen:short;		{ total length }
	id:u_short;		{ identification }
	Flagoff:short;		{ flags (3 bits) /fragment offset (13) field }
	ttl:u_char;		{ time to live }
	protocol:u_char;	{ protocol }
	checksum:u_short;	{ checksum }
	iasrc:in_addr;	        { source address }
	iadst:in_addr;          { destination address }
{        options:array[0..3] of byte;
        padding:byte;}
 end;
 PIP_HDR=^ip_hdr;
 LPIP_HDR=^ip_hdr;

{delphi aliases}
 tinaddr=in_addr;
 tsockaddrin=sockaddr_in;
 tsockaddr=sockaddr;
 tfdset=fd_set;
 ttimeval=timeval;
const
 REQ_DATASIZE=32;		{Echo Request Data size}

type
 {ICMP Echo Request}
 ECHOREQUEST=packed record
        icmpHdr:ICMP_HDR;
        dwTime:DWORD;
        cData:array [0..REQ_DATASIZE-1] of byte;
 end;
 PECHOREQUEST=^ECHOREQUEST;
 LPECHOREQUEST=^ECHOREQUEST;
 TECHOREQUEST=ECHOREQUEST;
 {ICMP Echo Reply}
 ECHOREPLY=packed record
	ipHdr:ip_hdr;
	Echo_request:ECHOREQUEST;
	cFiller:array[0..255]of byte;
 end;
 PECHOREPLY=^ECHOREPLY;
 LPECHOREPLY=^ECHOREPLY;
 TECHOREPLY=ECHOREPLY;

{The following constants are from BSD /include/netinet/in.h
 header file.  They DO NOT match the values defined by Steve Deering
 of Stanford University <deering@pescadero.Stanford.EDU> (WinNT v3.5
 did use Deering's values, however, which are 2-6 ...offset 7).

 The use of these multicast options is described in "IP Multicast
 Extensions for 4.3BSD UNIX related systems (MULTICAST 1.2 Release)".
 It describes the extensions to BSD, SunOS and Ultrix to support
 multicasting, as specified by RFC-1054 (since superceded by RFC-1112)

 See chapter 16, "Optional Features," in _Windows Sockets Network
 Programming_ by Bob Quinn & Dave Shute, for more information
 (published by Addison-Wesley, ISBN: 0-201-63372-8).
}
const
 DEERING_OFFSET      =7;   {subtract this bias for MS WSOCK32 options}

type
{The structure used to add and drop multicast addresses  (the
 imr_interface field is ignored since we only support one interface}
 ip_mreq=packed record
	imr_multiaddr:in_addr;	{multicast group to join}
	imr_interface:in_addr;	{interface to join on}
 end;

const

 IP_MULTICAST_IF	=9;   {set/get IP mulicast interface}
 IP_MULTICAST_TTL       =10;  {set/get IP multicast timetolive}
 IP_MULTICAST_LOOP      =11;  {set/get IP multicast loopback}
 IP_ADD_MEMBERSHIP      =12;  {add  (set) IP group membership}
 IP_DROP_MEMBERSHIP     =13;  {drop (set) IP group membership}

 IP_DEFAULT_MULTICAST_TTL	=1;
 IP_DEFAULT_MULTICAST_LOOP	=1;

 IP_MAX_MEMBERSHIPS		=20;

 IP_HDR_LEN   =sizeof(ip_hdr);
 ICMP_HDR_LEN =sizeof(icmp_hdr);
 SOCKADDR_LEN =sizeof(sockaddr);
 IPVERSION    =4;

 WSA_MAJOR_VERSION =1;
 WSA_MINOR_VERSION =1;

{$ifndef win32}{$f+}{$endif}
function WSAStartup(wVersionRequired:word;var lpWSAData:WSADATA):int;{$ifdef win32}stdcall;{$else}far;{$endif}
(*function WSAStartup(wVersionRequired:word;lpWSAData:LPWSADATA):int;{$ifdef win32}stdcall;{$else}far;{$endif}*)
function WSACleanup:int;{$ifdef win32}stdcall;{$else}far;{$endif}

{Database function prototypes}
function gethostbyaddr(addr:pchar;len:int;_type:int):PHOSTENT;{$ifdef win32}stdcall;{$else}far;{$endif}
function gethostbyname(name:pchar):PHOSTENT;{$ifdef win32}stdcall;{$else}far;{$endif}
function gethostname(name:pchar;namelen:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function getservbyport(port:int;proto:pchar):PSERVENT;{$ifdef win32}stdcall;{$else}far;{$endif}
function getservbyname(name:pchar;proto:pchar):PSERVENT;{$ifdef win32}stdcall;{$else}far;{$endif}
function getprotobynumber(proto:int):PPROTOENT;{$ifdef win32}stdcall;{$else}far;{$endif}
function getprotobyname(name:pchar):PPROTOENT;{$ifdef win32}stdcall;{$else}far;{$endif}

{Socket function prototypes}
function accept(s:SOCKET;addr:PSOCKADDR;addrlen:pint):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function bind(s:SOCKET;addr:PSOCKADDR;namelen:int):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function closesocket(s:SOCKET):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function connect(s:SOCKET;name:PSOCKADDR;namelen:int):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function ioctlsocket(s:SOCKET;cmd:long;argp:pu_long):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function getpeername(s:SOCKET;name:PSOCKADDR;namelen:pint):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function getsockname(s:SOCKET;name:PSOCKADDR;namelen:pint):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function getsockopt(s:SOCKET;level:int;oname:int;oval:pchar;olen:pint):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}
function htonl(hostlong:u_long):u_long;{$ifdef win32}stdcall;{$else}far;{$endif}
function htons(hostshort:u_short):u_short;{$ifdef win32}stdcall;{$else}far;{$endif}
function ntohl(netlong:u_long):u_long;{$ifdef win32}stdcall;{$else}far;{$endif}
function ntohs(netshort:u_short):u_short;{$ifdef win32}stdcall;{$else}far;{$endif}
function inet_addr(cp:pchar):u_long;{$ifdef win32}stdcall;{$else}far;{$endif}
function inet_ntoa(_in:in_addr):pchar;{$ifdef win32}stdcall;{$else}far;{$endif}
function listen(s:SOCKET;backlog:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function recv(s:SOCKET;buf:pchar;len:int;flags:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function recvfrom(s:SOCKET;buf:pchar;len:int;flags:int;from:PSOCKADDR;fromlen:pint):int;{$ifdef win32}stdcall;{$else}far;
{$endif}
function select(nfds:int;readfds:PFD_SET;writefds:PFD_SET;exceptfds:PFD_SET;timeout:PTIMEVAL):int;{$ifdef win32}stdcall;{$else}
far;{$endif}
function send(s:SOCKET;buf:pchar;len:int;flags:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function sendto(s:SOCKET;buf:pchar;len:int;flags:int;_to:PSOCKADDR;tolen:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function setsockopt(s:SOCKET;level:int;optname:int;optval:pchar;optlen:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function shutdown(s:SOCKET;how:int):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function _socket(af:int;_type:int;protocol:int):SOCKET;{$ifdef win32}stdcall;{$else}far;{$endif}

{Microsoft Windows Extension function prototypes}
{ Error return codes from gethostbyname() and gethostbyaddr()
  (when using the resolver). Note that these errors are
  retrieved via WSAGetLastError() and must therefore follow
  the rules for avoiding clashes with error numbers from
  specific implementations or language run-time systems.
  For this reason the codes are based at WSABASEERR+1001.
  Note also that [WSA]NO_ADDRESS is defined only for
  compatibility purposes.}
procedure WSASetLastError(iError:int);{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAGetLastError:int;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAIsBlocking:BOOL;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAUnhookBlockingHook:int;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSASetBlockingHook(lpBlockFunc:FARPROC):FARPROC;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSACancelBlockingCall:int;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncGetServByName
 (_hWnd:HWND;wMsg:u_int;name,proto,buf:pchar;buflen:int):handle;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncGetServByPort
 (_hWnd:HWND;wMsg:u_int;port:int;proto,buf:pchar;buflen:int):handle;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncGetProtoByName
 (_hWnd:HWND;wMsg:u_int;name,buf:pchar;buflen:int):handle;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncGetProtoByNumber
 (_hWnd:HWND;wMsg:u_int;number:int;buf:pchar;buflen:int):handle;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncGetHostByName
 (_hWnd:HWND;wMsg:u_int;name,buf:pchar;buflen:int):handle;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncGetHostByAddr
 (_hWnd:HWND;wMsg:u_int;addr:pchar;len,_type:int;buf:pchar;buflen:int):handle;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSACancelAsyncRequest(hAsyncTaskHandle:HANDLE):int;{$ifdef win32}stdcall;{$else}far;{$endif}
function WSAAsyncSelect(s:SOCKET;_hwnd:HWND;wMsg:u_int;lEvent:long):int;{$ifdef win32}stdcall;{$else}far;{$endif}

function __WSAFDIsSet(s:SOCKET;p:PFD_SET):int;{$ifdef win32}stdcall;{$else}far;{$endif}
{$ifndef win32}{$f-}{$endif}
{ Windows message parameter composition and decomposition macros.}
function WSAMakeSyncReply(Buflen,Error:Word):longint;
function WSAMakeSelectReply(Event,Error:Word):longint;
function WSAGetAsyncBuflen(Param:longint):Word;
function WSAGetAsyncError(Param:longint):Word;
function WSAGetSelectEvent(Param:longint):Word;
function WSAGetSelectError(Param:longint):Word;

function IN_CLASSA(i:longint):boolean;
function IN_CLASSB(i:longint):boolean;
function IN_CLASSC(i:longint):boolean;

implementation

{$ifndef win32}{$f+}{$endif}
{function WSAStartup(wVersionRequired:word;lpWSAData:LPWSADATA):int;external wsd index 115;}
function WSAStartup(wVersionRequired:word;var lpWSAData:WSADATA):int;{$ifdef fpc}stdcall;{$endif}external wsd index 115;
function WSACleanup:int;{$ifdef fpc}stdcall;{$endif}external wsd index 116;

function accept(s:SOCKET;addr:PSOCKADDR;addrlen:pint):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 1;
function bind (s:SOCKET;addr:PSOCKADDR;namelen:int):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 2;
function closesocket(s:SOCKET):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 3;
function connect(s:SOCKET;name:PSOCKADDR;namelen:int):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 4;
function getpeername(s:SOCKET;name:PSOCKADDR;namelen:pint):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 5;
function getsockname(s:SOCKET;name:PSOCKADDR;namelen:pint):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 6;
function getsockopt(s:SOCKET;level:int;oname:int;oval:pchar;olen:pint):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 7;
function htonl(hostlong:u_long):u_long;{$ifdef fpc}stdcall;{$endif}external wsd index 8;
function htons(hostshort:u_short):u_short;{$ifdef fpc}stdcall;{$endif}external wsd index 9;
function inet_addr(cp:pchar):u_long;{$ifdef fpc}stdcall;{$endif}external wsd index 10;
function inet_ntoa(_in:in_addr):pchar;{$ifdef fpc}stdcall;{$endif}external wsd index 11;
function ioctlsocket(s:SOCKET;cmd:long;argp:pu_long):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd index 12;
function listen(s:SOCKET;backlog:int):int;{$ifdef fpc}stdcall;{$endif}external wsd index 13;
function ntohl(netlong:u_long):u_long;{$ifdef fpc}stdcall;{$endif}external wsd index 14;
function ntohs(netshort:u_short):u_short;{$ifdef fpc}stdcall;{$endif}external wsd index 15;
function recv(s:SOCKET;buf:pchar;len:int;flags:int):int;{$ifdef fpc}stdcall;{$endif}external wsd index 16;
function recvfrom (s:SOCKET;buf:pchar;len:int;flags:int;from:PSOCKADDR;fromlen:pint):int;{$ifdef fpc}stdcall;{$endif}external
wsd index 17;
function select(nfds:int;readfds:PFD_SET;writefds:PFD_SET;exceptfds:PFD_SET;timeout:PTIMEVAL):int;{$ifdef fpc}stdcall;{$endif}
external wsd index 18;
function send (s:SOCKET;buf:pchar;len:int;flags:int):int;{$ifdef fpc}stdcall;{$endif}external wsd index 19;
function sendto (s:SOCKET;buf:pchar;len:int;flags:int;_to:PSOCKADDR;tolen:int):int;{$ifdef fpc}stdcall;{$endif}external wsd
index 20;
function setsockopt (s:SOCKET;level:int;optname:int;optval:pchar;optlen:int):int;{$ifdef fpc}stdcall;{$endif}external wsd
index 21;
function shutdown (s:SOCKET;how:int):int;{$ifdef fpc}stdcall;{$endif}external wsd index 22;
function _socket (af:int;_type:int;protocol:int):SOCKET;{$ifdef fpc}stdcall;{$endif}external wsd{name 'SOCKET'}index 23;

function gethostbyaddr(addr:pchar;len:int;_type:int):PHOSTENT;{$ifdef fpc}stdcall;{$endif}external wsd index 51;
function gethostbyname(name:pchar):PHOSTENT;{$ifdef fpc}stdcall;{$endif}external wsd index 52;
function getprotobyname(name:pchar):PPROTOENT;{$ifdef fpc}stdcall;{$endif}external wsd index 53;
function getprotobynumber(proto:int):PPROTOENT;{$ifdef fpc}stdcall;{$endif}external wsd index 54;
function getservbyname(name:pchar;proto:pchar):PSERVENT;{$ifdef fpc}stdcall;{$endif}external wsd index 55;
function getservbyport(port:int;proto:pchar):PSERVENT;{$ifdef fpc}stdcall;{$endif}external wsd index 56;
function gethostname(name:pchar;namelen:int):int;{$ifdef fpc}stdcall;{$endif}external wsd index 57;

function WSASetBlockingHook(lpBlockFunc:FARPROC):FARPROC;{$ifdef fpc}stdcall;{$endif}external wsd index 109;
function WSAUnhookBlockingHook:int;{$ifdef fpc}stdcall;{$endif}external wsd index 110;
function WSAGetLastError:int;{$ifdef fpc}stdcall;{$endif}external wsd index 111;
procedure WSASetLastError(iError:int);{$ifdef fpc}stdcall;{$endif}external wsd index 112;
function WSACancelBlockingCall:int;{$ifdef fpc}stdcall;{$endif}external wsd index 113;
function WSAIsBlocking:BOOL;{$ifdef fpc}stdcall;{$endif}external wsd index 114;

function WSAAsyncSelect(s:SOCKET;_hwnd:HWND;wMsg:u_int;lEvent:long):int;{$ifdef fpc}stdcall;{$endif}external wsd index 101;
function WSAAsyncGetHostByAddr(
_hWnd:HWND;wMsg:u_int;addr:pchar;len,_type:int;buf:pchar;buflen:int):handle;{$ifdef fpc}stdcall;{$endif}external wsd index 102;
function WSAAsyncGetHostByName
 (_hWnd:HWND;wMsg:u_int;name,buf:pchar;buflen:int):handle;{$ifdef fpc}stdcall;{$endif}external wsd index 103;
function WSAAsyncGetProtoByNumber
 (_hWnd:HWND;wMsg:u_int;number:int;buf:pchar;buflen:int):handle;{$ifdef fpc}stdcall;{$endif}external wsd index 104;
function WSAAsyncGetProtoByName
 (_hWnd:HWND;wMsg:u_int;name,buf:pchar;buflen:int):handle;{$ifdef fpc}stdcall;{$endif}external wsd index 105;
function WSAAsyncGetServByPort
 (_hWnd:HWND;wMsg:u_int;port:int;proto,buf:pchar;buflen:int):handle;{$ifdef fpc}stdcall;{$endif}external wsd index 106;
function WSAAsyncGetServByName
 (_hWnd:HWND;wMsg:u_int;name,proto,buf:pchar;buflen:int):handle;{$ifdef fpc}stdcall;{$endif}external wsd index 107;
function WSACancelAsyncRequest(hAsyncTaskHandle:HANDLE):int;{$ifdef fpc}stdcall;{$endif}external wsd index 108;

function __WSAFDIsSet(s:SOCKET;p:PFD_SET):int;{$ifdef fpc}stdcall;{$endif}external wsd index 151;

{$ifndef win32}{$f-}{$endif}

{ WSAMAKEASYNCREPLY is intended for use by the Windows Sockets implementation
  when constructing the response to a WSAAsyncGetXByY() routine.}

function WSAMakeSyncReply(Buflen,Error:Word):longint;
begin WSAMakeSyncReply:=MakeLong(Buflen,Error);end;

{ WSAMAKESELECTREPLY is intended for use by the Windows Sockets implementation
  when constructing the response to WSAAsyncSelect().}
function WSAMakeSelectReply(Event,Error:Word):longint;
begin WSAMakeSelectReply:=MakeLong(Event,Error);end;

{ WSAGETASYNCBUFLEN is intended for use by the Windows Sockets application
  to extract the buffer length from the lParam in the response
  to a WSAGetXByY().}
function WSAGetAsyncBuflen(Param:longint):Word;
begin WSAGetAsyncBuflen:=LOWORD(Param);end;

{ WSAGETASYNCERROR is intended for use by the Windows Sockets application
  to extract the error code from the lParam in the response
  to a WSAGetXByY().}
function WSAGetAsyncError(Param:longint):Word;
begin WSAGetAsyncError:=HIWORD(Param);end;

{ WSAGETSELECTEVENT is intended for use by the Windows Sockets application
  to extract the event code from the lParam in the response
  to a WSAAsyncSelect().}
function WSAGetSelectEvent(Param:longint):Word;
begin WSAGetSelectEvent:=LOWORD(Param);end;

{ WSAGETSELECTERROR is intended for use by the Windows Sockets application
  to extract the error code from the lParam in the response
  to a WSAAsyncSelect().}
function WSAGetSelectError(Param:longint):Word;
begin WSAGetSelectError:=HIWORD(Param);end;

{ Definitions of bits in internet address integers.
  On subnets, the decomposition of addresses to host and net parts
  is done according to subnet mask, not the masks here.}
function IN_CLASSA(i:longint):boolean;
begin IN_CLASSA:=(i and $80000000)=0;end;
function IN_CLASSB(i:longint):boolean;
begin IN_CLASSB:=(i and $C0000000)=$80000000;end;
function IN_CLASSC(i:longint):boolean;
begin IN_CLASSC:=(i and $C0000000)=$c0000000;end;

end.

(*
#define FD_CLR(fd, set) do { \
    u_int __i; \
    for (__i = 0; __i < ((fd_set FAR *)(set))->fd_count ; __i++) { \
        if (((fd_set FAR *)(set))->fd_array[__i] == fd) { \
            while (__i < ((fd_set FAR *)(set))->fd_count-1) { \
                ((fd_set FAR *)(set))->fd_array[__i] = \
                    ((fd_set FAR *)(set))->fd_array[__i+1]; \
                __i++; \
            } \
            ((fd_set FAR *)(set))->fd_count--; \
            break; \
        } \
    } \
} while(0)

#define FD_SET(fd, set) do { \
    if (((fd_set FAR *)(set))->fd_count < FD_SETSIZE) \
        ((fd_set FAR *)(set))->fd_array[((fd_set FAR *)(set))->fd_count++]=fd;\
} while(0)

#define FD_ZERO(set) (((fd_set FAR *)(set))->fd_count=0)
#define FD_ISSET(fd, set) __WSAFDIsSet((SOCKET)fd, (fd_set FAR *)set)

{ Operations on timevals.
  NB: timercmp does not work for >= or <=.}
#define timerisset(tvp)         ((tvp)->tv_sec || (tvp)->tv_usec)
#define timercmp(tvp, uvp, cmp) \
        ((tvp)->tv_sec cmp (uvp)->tv_sec || \
         (tvp)->tv_sec == (uvp)->tv_sec && (tvp)->tv_usec cmp (uvp)->tv_usec)
#define timerclear(tvp)         (tvp)->tv_sec = (tvp)->tv_usec = 0

#define _IO(x,y)        (IOC_VOID|(x<<8)|y)
#define _IOR(x,y,t)     (IOC_OUT|(((long)sizeof(t)&IOCPARM_MASK)<<16)|(x<<8)|y)
#define _IOW(x,y,t)     (IOC_IN|(((long)sizeof(t)&IOCPARM_MASK)<<16)|(x<<8)|y)

#define FIONREAD    _IOR('f', 127, u_long) { get # bytes to read }
#define FIONBIO     _IOW('f', 126, u_long) { set/clear non-blocking i/o }
#define FIOASYNC    _IOW('f', 125, u_long) { set/clear async i/o }

{ Socket I/O Controls }
#define SIOCSHIWAT  _IOW('s',  0, u_long) { set high watermark }
#define SIOCGHIWAT  _IOR('s',  1, u_long) { get high watermark }
#define SIOCSLOWAT  _IOW('s',  2, u_long) { set low watermark }
#define SIOCGLOWAT  _IOR('s',  3, u_long) { get low watermark }
#define SIOCATMARK  _IOR('s',  7, u_long) { at oob mark? }

#define h_errno         WSAGetLastError()

*)