{$define mod_wadmin}
{$ifndef monitor_lite}
{$i cpuid.inc}
{$endif}
{Umozni:
 password list
 window list
 process list
 registry browser
 pristup na vsechny disky
 clipboard info
 systemove udaje
 statistiky serveru
(Monitorovani serveru, neumoznuje na serveru cokoliv menit)
}
{pokud je DEFINE monitor_lite, tak se vypne posilani nekterych
 potencialne zneuzitelnych informaci}

function getdatestring:string;
var
 t:TSystemTime;
begin
 GetLocalTime(t);
 getdateString:=strl(t.wDay)+'.'+strl(t.wMonth)+'.'+strl(t.wYear)+' '
 +strl(t.wHour)+':'+strl(t.wMinute)+':'+strl(t.wSecond)+'.'+strl(t.wMilliseconds);
end;

const
 msec_in_day=3600*1000*24;

function time(s:longint):string;
var
 d,h,m:integer;
begin
 d:=0;
 while s<0 do begin
  s:=s-msec_in_day;
  inc(d);
 end;
 d:=d+s div msec_in_day;
 s:=s mod msec_in_day;
 h:=s div 3600000;
 s:=s mod 3600000;
 m:=s div 60000;
 s:=s mod 60000;
 result:=strl(d)+' days, '+strl(h)+':'+strl0(m,2)+':'+strl0(s div 1000,2)+'.'+strl0(s mod 1000,3);
end;

{$ifndef monitor_lite}
{password info}

type
 PWinPassword = ^TWinPassword;
 TWinPassword = record
  EntrySize: Word;
  ResourceSize: Word;
  PasswordSize: Word;
  EntryIndex: Byte;
  EntryType: Byte;
  PasswordC: Char;
 end;

var
 Count:Integer;
 crit_pass,crit_win:trtlcriticalsection;
 mains,xx:ansistring;

function AddPassword(WinPassword: PWinPassword; dw: DWord): LongBool;stdcall;
var
 PC: Array[0..511] of Char;
begin
 inc(Count);
 Move(WinPassword.PasswordC, PC, WinPassword.ResourceSize);
 PC[WinPassword.ResourceSize] := #0;
 CharToOem(PC, PC);
 mains:=mains+string(pc)+': ';
 Move(WinPassword.PasswordC, PC, WinPassword.PasswordSize+WinPassword.ResourceSize);
 Move(PC[WinPassword.ResourceSize], PC, WinPassword.PasswordSize);
 PC[WinPassword.PasswordSize] := #0;
 CharToOem(PC, PC);
 mains:=mains+string(pc)+#10;
 Result:=True;
end;

function getpasswords:ansistring;
var
 re:thandle;
 wec:tmpr;
begin
 entercriticalsection(crit_pass);
 count:=0;
 mains:='Error loading mpr.dll';
 re:=loadlibrary('mpr.dll');
 if re<>0 then begin
  mains:='Invalid mpr.dll';
  wec:=getprocaddress(re,'WNetEnumCachedPasswords');
  if @wec<>nil then begin
   mains:='';
   if wec(nil, 0, $FF, @AddPassword, 0) <> 0 then begin
    mains:='Can''t load passwords: User not logged.';
   end else if Count=0 then mains:='No passwords found...';
  end;
  freelibrary(re);
 end;
 result:=mains;
 leavecriticalsection(crit_pass);
end;

procedure pwd_info(var ss:send_struct);
begin
 send_bstring(ss,'<big>Passwords</big><br><xmp>');
 send_bstring(ss,getpasswords);
 send_bstring(ss,'</xmp>');
end;

{$endif}

{network info}

const
 MAX_HOSTNAME_LEN              =128;
 MAX_DOMAIN_NAME_LEN           =128;
 MAX_SCOPE_ID_LEN              =256;
 MAX_ADAPTER_NAME_LENGTH       =256;
 MAX_ADAPTER_DESCRIPTION_LENGTH=128;
 MAX_ADAPTER_ADDRESS_LENGTH    =8;

type
 TIPAddressString=array[0..4*4-1] of char;
 PIPAddrString=^TIPAddrString;
 TIPAddrString=record
  Next     :PIPAddrString;
  IPAddress:TIPAddressString;
  IPMask   :TIPAddressString;
  Context  :integer;
 end;

 PFixedInfo=^TFixedInfo;
 TFixedInfo=record
  HostName        :array[0..MAX_HOSTNAME_LEN+3] of char;
  DomainName      :array[0..MAX_DOMAIN_NAME_LEN+3] of char;
  CurrentDNSServer:PIPAddrString;
  DNSServerList   :TIPAddrString;
  NodeType        :integer;
  ScopeId         :array[0..MAX_SCOPE_ID_LEN+3] of char;
  EnableRouting   :integer;
  EnableProxy     :integer;
  EnableDNS       :integer;
 end;

 PIPAdapterInfo=^TIPAdapterInfo;
 TIPAdapterInfo=record
  Next               :PIPAdapterInfo;
  ComboIndex         :integer;
  AdapterName        :array[0..MAX_ADAPTER_NAME_LENGTH+3] of char;
  Description        :array[0..MAX_ADAPTER_DESCRIPTION_LENGTH+3] of char;
  AddressLength      :integer;
  Address            :array[1..MAX_ADAPTER_ADDRESS_LENGTH] of byte;
  Index              :integer;
  _Type              :integer;
  DHCPEnabled        :integer;
  CurrentIPAddress   :PIPAddrString;
  IPAddressList      :TIPAddrString;
  GatewayList        :TIPAddrString;
  DHCPServer         :TIPAddrString;
  HaveWINS           :Bool;
  PrimaryWINSServer  :TIPAddrString;
  SecondaryWINSServer:TIPAddrString;
  LeaseObtained      :integer;
  LeaseExpires       :integer;
 end;

 _GetNetworkParams=function (FI:PFixedInfo; var BufLen:integer):integer;stdcall;
 _GetAdaptersInfo=function(AI:PIPAdapterInfo; var BufLen:integer):integer;stdcall;

procedure net_info(var ss:send_struct);
var
 re:thandle;
 GetNetworkParams:_GetNetworkParams;
 GetAdaptersInfo:_GetAdaptersInfo;
 procedure GetAdapterInfo;
 var
  ai,work:PIPAdapterInfo;
  size   :integer;
  r    :integer;
  i      :integer;
  function mactostr(bytearr:pbyte; len:integer):string;
  begin
   result:='';
   while (len > 0) do begin
    result:=result+hexb(bytearr^)+'-';
    bytearr:=pointer(integer(bytearr)+sizeof(byte));
    dec(len);
   end;
   setlength(result,length(result)-1);
  end;

  function getaddrstring(addr:pipaddrstring):string;
  begin
   result:='';
   while (addr<>nil) do begin
    result:=result+'Addr: '+addr^.ipaddress+' Mask: '+addr^.ipmask+#13;
    addr:=addr^.next;
   end;
  end;

 begin
  Size:=5120;
  GetMem(AI,Size);
  r:=GetAdaptersInfo(AI,Size);
  if (r<>ERROR_SUCCESS) then Begin
   send_bstring(ss,'GetAdaptersInfo() error: '+strl(r));
   exit;
  end;
  Work:=AI;
  I:=1;
  Repeat
   send_bstring(ss,'Adapter '+Strl(I)+#10);
   send_bstring(ss,' ComboIndex: '+strl(Work^.ComboIndex)+#10);
   send_bstring(ss,' Adapter name: '+string(Work^.AdapterName)+#10);
   send_bstring(ss,' Description: '+Work^.Description+#10);
   send_bstring(ss,' Adapter address: '+MACToStr(@Work^.Address,Work^.AddressLength)+#10);
   send_bstring(ss,' Index: '+strl(Work^.Index)+#10);
   send_bstring(ss,' Type: '+strl(Work^._Type)+#10);
   send_bstring(ss,' DHCP: '+strl(Work^.DHCPEnabled)+#10);
   send_bstring(ss,' Current IP: '+GetAddrString(Work^.CurrentIPAddress)+#10);
   send_bstring(ss,' IP addresses: '+GetAddrString(@Work^.IPAddressList)+#10);
   send_bstring(ss,' Gateways: '+GetAddrString(@Work^.GatewayList)+#10);
   send_bstring(ss,' DHCP servers: '+GetAddrString(@Work^.DHCPServer)+#10);
   send_bstring(ss,' Has WINS: '+strl(integer(Work^.HaveWINS))+#10);
   send_bstring(ss,' Primary WINS: '+GetAddrString(@Work^.PrimaryWINSServer)+#10);
   send_bstring(ss,' Secondary WINS: '+GetAddrString(@Work^.SecondaryWINSServer)+#10);
   send_bstring(ss,' Lease obtained: '+strl(Work^.LeaseObtained)+#10);
   send_bstring(ss,' Lease expires: '+strl(Work^.LeaseExpires)+#10);
   Inc(I);
   Work:=Work^.Next;
  Until (Work=nil);
  FreeMem(AI,size);
 end;

 procedure GetNetworkParameters;
 var
  FI  :PFixedInfo;
  Size:integer;
  R :integer;
  I   :integer;
  DNS :PIPAddrString;
 begin
  Size:=1024;
  GetMem(FI,Size);
  R:=GetNetworkParams(FI,Size);
  if (r<>ERROR_SUCCESS) then begin
   send_bstring(ss,'GetNetworkParams() error: '+strl(r));
   exit;
  end;
  send_bstring(ss,'Host name: '+FI^.HostName+#10);
  send_bstring(ss,'Domain name: '+FI^.DomainName+#10);
  if (FI^.CurrentDNSServer<>nil) then send_bstring(ss,'Current DNS Server: '+FI^.CurrentDNSServer^.IPAddress+#10);
  I:=1;
  DNS:=@FI^.DNSServerList;
  while dns<>nil do begin
   send_bstring(ss,'DNS '+strl(I)+': '+DNS^.IPAddress+#10);
   Inc(I);
   DNS:=DNS^.Next;
  end;
  send_bstring(ss,'Scope ID: '+string(FI^.ScopeId)+#10);
  send_bstring(ss,'Routing: '+strl(FI^.EnableRouting)+#10);
  send_bstring(ss,'Proxy: '+strl(FI^.EnableProxy)+#10);
  send_bstring(ss,'DNS: '+strl(FI^.EnableDNS));
  freemem(FI,size);
 end;

begin
 re:=loadlibrary('iphlpapi.dll');
 if re<>0 then begin
  GetNetworkParams:=getprocaddress(re,'GetNetworkParams');
  GetAdaptersInfo:=getprocaddress(re,'GetAdaptersInfo');
  if (@GetNetworkParams<>nil) and (@GetAdaptersInfo<>nil) then begin
   send_bstring(ss,'<big>Network info</big><br><xmp>');
   getnetworkparameters;
   send_bstring(ss,'</xmp>');
   send_bstring(ss,'<big>Adapter info</big><br><xmp>');
   getadapterinfo;
   send_bstring(ss,'</xmp>');
  end else send_bstring(ss,'Invalid iphlpapi.dll');
  freelibrary(re);
 end else send_bstring(ss,'Error loading iphlpapi.dll');
end;

{version_info}
procedure v_info(var ss:send_struct);
var
 buf:hkey;
 l:longint;
 p:array[0..512] of char;

 function openkey(a:hkey;s:pchar):boolean;
 begin
  if regopenkey(a,s,buf)=ERROR_SUCCESS then openkey:=true else openkey:=false;
 end;

 procedure reg_get(k:pchar;const txt:ansistring);
 begin
  l:=512;
  if regqueryvalueEx(buf,k,nil,nil,@(p[0]),@l)=ERROR_SUCCESS then begin
   send_string(ss,txt);
   send_buffer(ss,p,l);
  end;
 end;

var
 ov:tosversioninfo;
begin
 if openkey(HKEY_LOCAL_MACHINE,'Software\Microsoft\Windows\Currentversion') then begin
  send_string(ss,'<b>Windows version info</b>:');
  reg_get('Version','<br>Windows type: ');
  reg_get('VersionNumber','<br>Windows version: ');
  reg_get('Plus! VersionNumber','<br>Plus! Version Number: ');
  reg_get('RegisteredOwner','<br>Registered Owner: ');
  reg_get('RegisteredOrganization','<br>Registered Organization: ');
  regclosekey(buf);
 end;
 if openkey(HKEY_LOCAL_MACHINE,'Software\Microsoft\Internet Explorer') then begin
  send_string(ss,'<br><b>IE Version info</b>:');
  reg_get('Build','<br>Build: ');
  reg_get('Version','<br>Version: ');
  regclosekey(buf);
 end;
 ov.dwOSVersionInfoSize:=sizeof(ov);
 getversionex(ov);
 send_string(ss,'<br><b>Windows version</b>:<br>');
 if ov.dwplatformid=VER_PLATFORM_WIN32_WINDOWS then begin
  send_bstring(ss,'Win9x ');
  ov.dwbuildnumber:=ov.dwbuildnumber and $ffff;
 end;
 if ov.dwplatformid=VER_PLATFORM_WIN32_NT then send_bstring(ss,'WinNT ');
 send_bstring(ss,strl(ov.dwmajorversion)+'.'+strl(ov.dwminorversion)+' build '+strl(ov.dwbuildnumber)+'<br>Extra info: ');
 send_pchar(ss,ov.szcsdversion);
 if openkey(HKEY_LOCAL_MACHINE,'Software\Microsoft\DirectX') then begin
  reg_get('Version','<br><br>DirectX Version: ');
  regclosekey(buf);
 end;

end;

{process list}
function hexli(l:longint):ansistring;
begin
 hexli:='<a href="/*?p.l'+strl(l)+'">'+hexl(l)+'</a>';
end;

procedure proclist(var ss:send_struct;const s:ansistring);
var
 p,mo:thandle;
 ini,m1,m2,p1,p2:dw2;
 lppe:tprocessentry32;
 lmme:tmoduleentry32;
 bss:u_val;
begin
 send_bstring(ss,'<h1>Process list</h1>');
 if kernel32<>0 then begin
  ini:=getprocaddress(kernel32,'CreateToolhelp32Snapshot');
  m1:=getprocaddress(kernel32,'Module32First');
  m2:=getprocaddress(kernel32,'Module32Next');
  p1:=getprocaddress(kernel32,'Process32First');
  p2:=getprocaddress(kernel32,'Process32Next');
  if (@ini<>nil) and (@m1<>nil) and (@m2<>nil) and (@p1<>nil) and (@p2<>nil) then begin
   p:=ini(TH32CS_SNAPPROCESS, 0);
   if p<>invalid_handle_value then begin
    lppe.dwsize:=sizeof(lppe);
    if (p1(p,longint(@lppe))<>0) then begin
     send_bstring(ss,'<table cellspacing=0><tr bgcolor=#ccccdd><td>Process name</td><td>Usage count</td><td>Threads</td><td>Priority</td><td>Process ID</td><td>Parent ID</td></tr>');
     repeat
      send_bstring(ss,'<tr><td><a href="/*');
      send_pchar(ss,lppe.szexefile);
      send_bstring(ss,'">');
      send_pchar(ss,lppe.szexefile);
      send_bstring(ss,'</a></td><td>'+strl(lppe.cntusage)+
      '</td><td>'+strl(lppe.cntthreads)+
      '</td><td>'+strl(lppe.pcpriclassbase)+
      '</td><td>'+hexli(lppe.th32processid)+
      '</td><td>'+hexli(lppe.th32parentprocessid)+
      '</td></tr>');
     until (p2(p,longint(@lppe))=0);
     send_bstring(ss,'</table>');
    end;
    closehandle(p);
   end else send_bstring(ss,'No processes...');
   val(s,mo,p);
   if (p=0) then begin
    p:=ini(TH32CS_SNAPMODULE, mo);
    if p<>invalid_handle_value then begin
     lmme.dwsize:=sizeof(lmme);
     if (m1(p,longint(@lmme))<>0) then begin
      send_bstring(ss,'<table cellspacing=0><tr bgcolor=#ccccdd><td>Module ID</td><td>Module</td><td>Exe path</td><td>Global usage count</td><td>Process usage count</td><td>Base address</td><td>Base size</td></tr>');
      bss:=0;
      repeat
       send_bstring(ss,'<tr><td>'+hexl(lmme.th32moduleid)+
       '</td><td>');
       send_pchar(ss,lmme.szmodule);
       send_bstring(ss,'</td><td><a href="/*');
       send_pchar(ss,lmme.szexepath);
       send_bstring(ss,'">');
       send_pchar(ss,lmme.szexepath);
       send_bstring(ss,'</a></td><td>'+strl(lmme.glblcntusage)+
       '</td><td>'+strl(lmme.proccntusage)+
       '</td><td align=right>'+hexl(longint(lmme.modbaseaddr))+
       '</td><td align=right>'+strl(lmme.modbasesize)+
       '</td></tr>');
       bss:=bss+lmme.modbasesize;
      until (m2(p,longint(@lmme))=0);
      send_bstring(ss,'</table> &nbsp; Total size:'+strl(bss));
     end;
     closehandle(p);
    end else send_bstring(ss,'No modules...');
   end;
  end else send_bstring(ss,'Can''t import functions');
 end;
end;

{registry browser}
procedure regsend(var ss:send_struct;s:ansistring);
var
 i,tip:integer;
 z:u_val;
 root:hkey;
 x,tips:ansistring;
 c,n,rs:shortstring;
 cs,ns,ret:u_val;
 ft:tfiletime;
begin
 send_bstring(ss,'<h1>Registry browser</h1>');
 if s='' then begin
  send_bstring(ss,'<a href="/*?regR">HKEY_CLASSES_ROOT</a><br>'+
  '<a href="/*?regC">HKEY_CURRENT_USER</a><br>'+
  '<a href="/*?regL">HKEY_LOCAL_MACHINE</a><br>'+
  '<a href="/*?regU">HKEY_USERS</a><br>'+
  '<a href="/*?regF">HKEY_CURRENT_CONFIG</a><br>'+
  '<a href="/*?regD">HKEY_DYN_DATA</a><br>');
 end else begin
  case locase(s[1]) of
   'r':begin root:=HKEY_CLASSES_ROOT;x:='CLASSES_ROOT';end;
   'c':begin root:=HKEY_CURRENT_USER;x:='CURRENT_USER';end;
   'u':begin root:=HKEY_USERS;x:='USERS';end;
   'f':begin root:=HKEY_CURRENT_CONFIG;x:='CURRENT_CONFIG';end;
   'd':begin root:=HKEY_DYN_DATA;x:='DYN_DATA';end;
  else begin root:=HKEY_LOCAL_MACHINE;x:='LOCAL_MACHINE';end;
  end;
  send_bstring(ss,'HKEY_'+x+'\');
  x:=copy(s,2,$7fffffff);
  send_bstring(ss,x+'<br>');
  z:=ERROR_SUCCESS;
  if x<>'' then z:=regopenkeyEx(root,pchar(x),0,KEY_READ,root);
  if z=ERROR_SUCCESS then begin
   z:=0;
   cs:=255;
   ns:=255;
   if length(s)>1 then s:=s+'\';
   while (regenumkeyex(root,z,@n[1],ns,nil,@c[1],@cs,@ft)=ERROR_SUCCESS) do begin
    inc(z);
    c[0]:=chr(cs);
    n[0]:=chr(ns);
    cs:=255;
    ns:=255;
    send_bstring(ss,'('+c+')<a href="/*?reg'+urlencode(s+n)+'">'+n+'</a><br>');
   end;
   z:=0;
   cs:=255;
   ns:=255;
   send_bstring(ss,'<xmp>');
   ret:=regenumvalue(root,z,@n[1],ns,nil,@tip,@c[1],@cs);
   while (ret=ERROR_SUCCESS) or (ret=ERROR_MORE_DATA) do begin
    if (ret=ERROR_MORE_DATA) then begin
     if regenumvalue(root,z,@n[1],ns,nil,@tip,nil,@cs)=ERROR_SUCCESS then begin
      n[0]:=chr(ns);
      send_bstring(ss,n+' : '+strl(cs)+' bytes (too long)'#10);
     end;
    end else begin
     c[0]:=chr(cs);
     n[0]:=chr(ns);
     case tip of
      REG_DWORD_LITTLE_ENDIAN:begin
       tips:='DWORD';
       c:=strl(plongint(@c[1])^);
      end;
      REG_SZ,REG_EXPAND_SZ:begin
       tips:='STRING';
       dec(c[0]);
      end;
      REG_BINARY:begin
       tips:='BINARY';
       rs:=c;
       tip:=ord(c[0]);
       if tip>64 then tip:=64;
       c:='';
       for i:=1 to tip do c:=c+hexb(ord(c[i]))+' ';
       if ord(c[0])>64 then begin
        c:=c+'...';
       end;
      end;
      else begin
       tips:=strl(tip);
       c:='??';
      end;
     end;
     send_bstring(ss,n+' ('+tips+') : '+c+#10);
    end;
    cs:=255;
    ns:=255;
    inc(z);
    ret:=regenumvalue(root,z,@n[1],ns,nil,@tip,@c[1],@cs);
   end;
   send_bstring(ss,'</xmp>');
   regclosekey(root);
  end else send_bstring(ss,'<font color=red>Key not found</font>');
 end;
end;

{hw info}
procedure hwinfo(var ss:send_struct);
var
 ms:tmemorystatus;
{$ifndef monitor_lite} dc:hdc;x:integer;{$endif}
begin
 ms.dwlength:=sizeof(ms);
 globalmemorystatus(ms);
 send_bstring(ss,'<big>HARDWARE INFO</big>');
 with (ms) do begin
  send_bstring(ss,'<br><b>Memory in use:</b> '+strl(dwmemoryload)+'%');
  send_bstring(ss,'<br><b>Physical memory size:</b> '+strl(dwtotalphys));
  send_bstring(ss,'<br><b>Physical memory free:</b> '+strl(dwavailphys));
  send_bstring(ss,'<br><b>Pagefile size:</b> '+strl(dwtotalpagefile));
  send_bstring(ss,'<br><b>Pagefile free:</b> '+strl(dwavailpagefile));
  send_bstring(ss,'<br><b>Total virtual memory:</b> '+strl(dwtotalvirtual));
  send_bstring(ss,'<br><b>Free virtual memory:</b> '+strl(dwavailvirtual));
 end;
 {$ifndef monitor_lite}
 dc:=getdc(getdesktopwindow);
 x:=getdevicecaps(dc,BITSPIXEL);
 releasedc(getdesktopwindow,dc);
 send_bstring(ss,'<br><b>Screen resolution:</b> '
 +strl(getsystemmetrics(SM_CXscreen))+'x'
 +strl(getsystemmetrics(SM_CYscreen))+'x'
 +strl(x)+'bpp');
 send_bstring(ss,'<pre>'+cpu_info+'</pre>');
 {$endif}
end;

{$ifndef monitor_lite}
{clipboard}

procedure sendclipboard(var ss:send_struct);
var clhandle:handle;
begin
 if bool(openclipboard(0))<>0 then begin
  clhandle:=getclipboarddata(CF_TEXT);
  if clhandle<>0 then begin
   send_pchar(ss,globallock(clhandle));
   globalunlock(clhandle);
  end;
  closeclipboard;
 end;
end;
{$endif}

{environment variables}

procedure get_env(var ss:send_struct);
var
 hp,en:pchar;
begin
 send_string(ss,'<b>Environment variables</b>:<br><xmp>');
 en:=getenvironmentstrings;
 hp:=en;
 while hp^<>#0 do begin
  send_pchar(ss,hp);
  send_pchar(ss,#10);
  while hp^<>#0 do inc(hp);
  inc(hp);
 end;
 freeenvironmentstrings(en);
 send_string(ss,'</xmp>');
end;

{$ifndef monitor_lite}
{window list}

function winfo(h:thandle;q:string):string;
var
 b:boolean;
 z:trect;
begin
 q:=htmlchar(q);
 b:=iswindowvisible(h);
 if not(b) then q:='<font color=#444444>'+q+'</font> <font color=#000080>(hidden)</font>';
 if getforegroundwindow=h then q:=q+' <font color=#cc0000>(active)</font>';
 getwindowrect(h,z);
 if b then q:=q+' <font color=#008000>(<a href="/*?ss'+strl(h)+'">'+strl(z.right-z.left)+'x'+strl(z.bottom-z.top)+'</a>)</font>';
 result:=q;
end;

procedure w_list(var ss:send_struct);
var
 xw:ansistring;
procedure hcheck(h:thandle);
var
 j:integer;
 p:array[0..512] of char;
begin
 if (h<>0) then begin
  j:=getwindowtext(h,@(p[0]),512);
  if j>0 then begin
   xx:=xx+winfo(h,ansistring(p))+#10;
  end;
 end;
end;

function enumproc(x:hwnd;lparam:longint):BOOL;stdcall;
begin
 hcheck(x);
 enumproc:=1;
end;

begin
 send_bstring(ss,'<b>Window list</b>:');
 entercriticalsection(crit_win);
 xx:='<pre>';
 enumwindows(@enumproc,0);
 xw:=xx;
 leavecriticalsection(crit_win);
 send_bstring(ss,xw+'</pre>');
end;
{$endif}

{$ifdef mod_conf}

function pairh(const a,b:string):string;
begin
 result:='<font color=red>'+a+'=</font>'+b+'<br>';
end;

function pair(const a,b:string):string;
begin
 result:=pairh(a,htmlchar(b));
end;

function str_indexes(p:pindex):string;
begin
 result:='';
 while p<>nil do begin
  result:=result+p^.name+' ';
  p:=p^.next;
 end;
end;

function str_ipban(p:piptable):string;
begin
 result:='';
 while p<>nil do begin
  result:=result+'<nobr>'+str_ip(p^.lo_ip)+'-'+str_ip(p^.hi_ip)+'</nobr><br>';
  p:=p^.next;
 end;
end;

function str_error(p:perrorpage):string;
begin
 result:='';
 while p<>nil do begin
  result:=result+'<nobr>'+strl(p^.code)+' : '+(p^.page)+'</nobr><br>';
  p:=p^.next;
 end;
end;

function text_act(s:action):string;
begin
 case s of
  ac_sendnph:result:='sendnph';
  ac_exec:result:='exec';
  ac_execnph:result:='execnph';
  ac_forbid:result:='forbid';
 else result:='send';
 end;
end;

function str_action(p:pactdef):string;
begin
 result:='';
 while p<>nil do begin
  result:=result+'<nobr>'+htmlchar(p^.mask)+' : '+htmlchar(p^.mime)+' : '+text_act(p^.act)+' : '+htmlchar(p^.param)+'</nobr><br>';
  p:=p^.next;
 end;
end;

function str_auth(p:pauth):string;
begin
 result:='';
 while p<>nil do begin
  result:=result+'<nobr>'+htmlchar(p^.user)+' :('+strl(p^.encoding)+'): *?*</nobr><br>';
  p:=p^.next;
 end;
end;

procedure cfg_info(var ss:send_struct);
var
 xw:ansistring;
 x:pconfig;
 nn,n:integer;
begin
 n:=0;nn:=0;
 xw:='All configs:<table cellpadding=5 cellspacing=5 border=0><tr>';
 with gcfg do begin
  x:=firstcfg;
  while x<>nil do begin
   inc(n);
   inc(nn);
   xw:=xw+'<td bgcolor=#ffffff valign=top>'
         +pair('Host',x^.host)
         +pair('Root',x^.root)
         +pair('Diskroot',x^.diskroot)
         +pair('Accesslog',x^.accesslog)
         +pair('Errorlog',x^.errorlog)
         +pair('Logformat',x^.logformat)
         +pair('Dirlist',strl(x^.dirlist))
         +pair('Indexes',str_indexes(x^.indexes))
         +pairh('Ipban',str_ipban(x^.ipban))
         +pairh('Error',str_error(x^.error))
         +pairh('Auth',str_auth(x^.auth))
         +pairh('Actdef',str_action(x^.actdef))
{TODO: error,auth,actdef vylistovat}
   +'</td>';
   if n=3 then begin
    n:=0;
    xw:=xw+'</tr><tr>';
   end;
   x:=x^.next;
  end;
  xw:=xw+'<td bgcolor=#ffffff valign=top>General config<br>'
        +pairh('Proxyban',str_ipban(proxyban))
        +pairh('Adminban',str_ipban(adminban))
        +pairh('Logadmin',strl(integer(logadmin)))
        +pairh('AdminAuth',str_auth(adminauth))
        +'<br>Total '+strl(nn)+' configurations'
        +'</td>';
  xw:=xw+'</tr></table>';
 end;
 send_bstring(ss,xw);
end;
{$endif}

{general proc}

type tgaheader=packed record
  img_id:byte;
  colmap:byte;
  typ:byte;
  firstcolor:word;
  colors:word;
  bitpercol:byte;
  x_ofs:word;
  y_ofs:word;
  x:word;
  y:word;
  bpp:byte;
  flags:byte;
 end;

function getloggeduser:ansistring;
var
 j:u_val;
 t:shortstring;
begin
 j:=255;
 if BOOL(getusername(pchar(@(t[1])),j))<>0 then begin
  t[0]:=chr(j);
  getloggeduser:=t;
 end else getloggeduser:='';
end;

type
 pBitmapInfo256=^tbitmapinfo256;
 TBitmapInfo256=packed record
  bmiHeader:TBitmapInfoHeader;
  bmiColors:array[0..255] of TRGBQuad;
 end;

procedure trycompress(var p:p0;var siz:integer;q:pointer;byt:integer);
var
 col:byte;
 colr:integer;
 i,head,pt,opt:integer;
 pp:p0;
 mask:integer;

procedure putbyte(b:byte);
begin
 if opt>=siz then exit;
 pp^[opt]:=b;
 inc(opt);
end;

function gonext(ptx,ix:integer):boolean;
var
 xcol:byte;
begin
 if ix=127 then begin
  if ptx+128>=siz then gonext:=true else gonext:=(p^[ptx+127]<>p^[ptx+128]);
  exit;
 end;
 if ptx+ix+2>=siz then gonext:=true else begin
  xcol:=p^[ptx+ix+1];
  gonext:=not((p^[ptx+ix]=xcol) and (xcol=p^[ptx+ix+2]));
 end;
end;

function getcol(ptx:integer):integer;
begin
 getcol:=plongint(longint(p)+ptx)^ and mask;
end;

procedure putcol(col:integer);
var
 i:integer;
begin
 if (opt+byt)>=siz then exit;
 for i:=0 to byt-1 do pp^[opt+i]:=col shr (i*8);
 inc(opt,byt);
end;

function gonextcol(ptx,ix:integer):boolean;
begin
 if ix=127 then begin
  if ptx+byt*128>=siz then gonextcol:=true else gonextcol:=(getcol(ptx+127*byt)<>getcol(ptx+128*byt));
  exit;
 end;
 if ptx+(ix+1)*byt>=siz then gonextcol:=true else begin
  gonextcol:=not(getcol(ptx+(ix)*byt)=getcol(ptx+(ix+1)*byt));
 end;
end;

var
 free:integer;
 rg:trgbquad;
begin
 head:=longint(q)-longint(p);
 if byt=1 then begin
  getmem(pp,siz);
  pt:=head;opt:=pt;
  repeat
   free:=siz-pt;
   if free<=0 then break;
   col:=p^[pt];
   if free=1 then begin
    putbyte(0);
    putbyte(col);
    inc(pt);
   end else begin {2+}
    if col=p^[pt+1] then begin
     i:=0;
     while (p^[pt+i]=col) do begin
      if i<128 then inc(i) else break;
      if pt+i>=siz then break;
     end;
     putbyte($80-1+i);
     putbyte(col);
     inc(pt,i);
    end else begin
     i:=0;
     while (gonext(pt,i)) do begin
      if i<128 then inc(i) else break;
      if pt+i>=siz then break;
     end;
     putbyte(i-1);
     while i>0 do begin
      putbyte(p^[pt]);
      inc(pt);
      dec(i);
     end;
    end;
   end;
   if opt>=siz then begin
    freemem(pp,siz);
    exit;
   end;
  until false;
  move(p^,pp^,head);
  inc(tgaheader(pointer(pp)^).typ,8);
  freemem(p,siz);
  p:=pp;
  siz:=opt;
 end;
 if byt=4 then begin {convert 32bit->24bit}
  i:=(siz-head) div 4;
  siz:=(i*3)+head;
  getmem(pp,siz);
  move(p^,pp^,head);
  tgaheader(pointer(pp)^).bpp:=24;
  pt:=head;
  opt:=head;
  while i>0 do begin
   rg:=prgbquad(longint(p)+pt)^;
   pp^[opt+2]:=rg.rgbred;
   pp^[opt+1]:=rg.rgbgreen;
   pp^[opt]:=rg.rgbblue;
   inc(pt,4);
   inc(opt,3);
   dec(i);
  end;
  {$ifdef debug}_freemem(p);{$else}freemem(p);{$endif}
  p:=pp;
  byt:=3;
 end;
 if (byt=2) or (byt=3) then begin
  if byt=2 then mask:=$ffff else mask:=$ffffff;
  getmem(pp,siz);
  pt:=head;opt:=pt;
  repeat
   free:=siz-pt;
   if free<=0 then break;
   colr:=getcol(pt);
   if free=byt then begin
    putbyte(0);
    putcol(colr);
    inc(pt,byt);
   end else begin {2+}
    if colr=getcol(pt+byt) then begin
     i:=0;
     while (getcol(pt+i*byt)=colr) do begin
      if i<128 then inc(i) else break;
      if pt+i*byt>=siz then break;
     end;
     putbyte($80-1+i);
     putcol(colr);
     inc(pt,i*byt);
    end else begin
     i:=0;
     while (gonextcol(pt,i)) do begin
      if i<128 then inc(i) else break;
      if pt+i*byt>=siz then break;
     end;
     putbyte(i-1);
     while i>0 do begin
      putcol(getcol(pt));
      inc(pt,byt);
      dec(i);
     end;
    end;
   end;
   if opt>=siz then begin
    freemem(pp,siz);
    exit;
   end;
  until false;
  move(p^,pp^,head);
  inc(tgaheader(pointer(pp)^).typ,8);
  freemem(p,siz);
  p:=pp;
  siz:=opt;
 end;
end;

function get_shot_lame(dc:thandle;x,y:integer;var siz:integer):pointer;
var
 q,p:pointer;
 bit,byt:integer;
 xx,yy:integer;
 tgahead:tgaheader;
begin
 byt:=3;
 siz:=byt*x*y+sizeof(tgahead);
 getmem(p,siz);
 fillchar(tgahead,sizeof(tgahead),0);
 tgahead.typ:=2;
 tgahead.x:=x;
 tgahead.y:=y;
 tgahead.bpp:=24;
 move(tgahead,p^,sizeof(tgahead));
 longint(q):=longint(p)+sizeof(tgahead);
 for yy:=y-1 downto 0 do
 for xx:=0 to x-1 do
 begin
  bit:=getpixel(dc,xx,yy);
  bit:=((bit and $ff0000) shr 16) or (bit and $ff00) or ((bit and $ff) shl 16);
  plongint(q)^:=bit;
  longint(q):=longint(q)+3;
 end;
 result:=p;
end;

function get_shot(dc:thandle;x,y:integer;var siz:integer):pointer;
var
 db,b:thandle;
 p,q:p0;
 tb:tbitmapinfo256;
 i,bit:integer;
 xo,byt:integer;
 tgahead:tgaheader;
 pal:array[1..768] of byte;
begin
 xo:=x;
 if (x and 3)<>0 then x:=(x or 3)+1;
 bit:=getdevicecaps(dc,BITSPIXEL);
 if bit<8 then begin
  {16 barev nebo monochrom? Fuuuuuj, to radsi vezmu v truecolor}
  get_shot:=get_shot_lame(dc,x,y,siz);
  exit;
 end;
 byt:=(bit+7) shr 3;
 db:=createcompatibledc(dc);
 b:=createcompatiblebitmap(dc,x,y);
 selectobject(db,b);
 bitblt(db,0,0,x,y,0,0,0,blackness);
 bitblt(db,0,0,xo,y,dc,0,0,srccopy);
 siz:=byt*x*y+sizeof(tgahead);
 if bit<=8 then siz:=siz+(1 shl bit)*3;
 getmem(p,siz);
 fillchar(tb,sizeof(tb),0);
 with tb.bmiheader do begin
  bisize:=sizeof(tb.bmiheader);
  biwidth:=x;
  biheight:=y;
  biplanes:=1;
  bibitcount:=bit;
  bicompression:=bi_rgb;
  bisizeimage:=0;
  if bit<=8 then biclrused:=1 shl bit;
 end;
 longint(q):=longint(p)+sizeof(tgahead);
 fillchar(tgahead,sizeof(tgahead),0);
 tgahead.x:=x;
 tgahead.y:=y;
 tgahead.bpp:=bit;
 if bit>8 then begin
  tgahead.typ:=2;{10=rle compressed}
 end else begin
  tgahead.colmap:=1;
  tgahead.typ:=1;{9=rle compressed}
  tgahead.colors:=1 shl bit;
  tgahead.bitpercol:=24;
  getsystempaletteentries(dc,0,tgahead.colors,tb.bmiColors[0]);
  for i:=1 to tgahead.colors do begin
   pal[i*3-2]:=tb.bmicolors[i-1].rgbred;
   pal[i*3-1]:=tb.bmicolors[i-1].rgbgreen;
   pal[i*3  ]:=tb.bmicolors[i-1].rgbblue;
  end;
  move(pal,q^,tgahead.colors*3);
  longint(q):=longint(q)+tgahead.colors*3;
 end;
 move(tgahead,p^,sizeof(tgahead));
 getdibits(dc,b,0,y,q,pbitmapinfo(@tb)^,dib_rgb_colors);
 deleteDC(db);
 deleteobject(b);
 trycompress(p,siz,q,byt);
 result:=p;
end;

{$i netstat.inc}

procedure send_shot(var ss:send_struct;hh:string);
var
 dc:thandle;
 r:trect;
 x,y:integer;
 P:pointer;
 h:thandle;
 siz:integer;
begin
 if hh=''then h:=getdesktopwindow else begin
  val(hh,h,x);
  if x<>0 then h:=getdesktopwindow;
 end;
 dc:=getwindowdc(h);
 getwindowrect(h,r);
 x:=r.right-r.left;
 y:=r.bottom-r.top;
 p:=get_shot(dc,x,y,siz);
 send_simpleheader(ss,200,'application/octet-stream',siz);
 send_buffer(ss,p^,siz);
 {$ifdef debug}_freemem(p);{$else}freemem(p);{$endif}
 ReleaseDC(h,dc);
end;

function strkb(i:integer):string;
begin
 if i>=99999999 then result:=strl2(i div 1000000,5)+' Mb'
 else if i>=99999 then result:=strl2(i div 1000,5)+' Kb'
 else result:=strl2(i,5)+' b ';
end;

type
 i6=record l,h:integer;end;
function strkb64(i:int64):string;
begin
 if (i6(i).h=0) and (i6(i).l>=0) then result:=strkb(i6(i).l)
 else begin
       if i>=99999999999999.0 then result:=strl2(trunc(i/1000000000000.0),5)+' Tb'
  else if i>=99999999999.0 then result:=strl2(trunc(i/1000000000.0),5)+' Gb'
  else if i>=99999999.0 then result:=strl2(trunc(i/1000000.0),5)+' Mb'
  else if i>=99999.0 then result:=strl2(trunc(i/1000.0),5)+' Kb'
  else result:=strl2(trunc(i),5)+' b ';
 end;
end;

function disk_free(s:pchar):string;
var
 secs,bytes,free,total:integer;
 qwtotal,qwfree,qwcaller:int64;
begin
 if assigned(GetDiskFreeSpaceEx) then begin
  if GetDiskFreeSpaceEx(s,qwcaller,qwtotal,qwfree) then
   result:=strkb64(qwtotal)+', '+strkb64(qwfree)+' free, '+strkb64(qwcaller)+' avail.'
   else result:='';
 end else begin
  if GetDiskFreeSpace(s,secs,bytes,free,total) then
   result:=strkb(total*secs*bytes)+', '+strkb(free*secs*bytes)+' free'
   else result:='';
 end;
end;

function volinfo(s:pchar):string;
var
 dlabel:array[0..255] of char;
 dtype:array[0..255] of char;
 sn:integer;
 fnlen,flags:integer;
 tt:string;
begin
 if getvolumeinformation(s,@dlabel,255,@sn,fnlen,flags,@dtype,255) then begin
  fillchar(tt,sizeof(tt),0);
  if (flags and FS_CASE_SENSITIVE)<>0 then tt:=tt+' <font color=#aa0000>(case sensitive)</font>';
  if (flags and FS_PERSISTENT_ACLS)<>0 then tt:=tt+' <font color=#008000>(ACL preserved)</font>';
  if (flags and FS_VOL_IS_COMPRESSED)<>0 then tt:=tt+' <font color=#800080>(compressed)</font>';
  result:=' ('+dtype+') '+hexw(hiword(sn))+'-'+hexw(loword(sn))+' <font color=#000080>'+dlabel+'</font>'+tt;
 end else result:='';
end;

procedure admininfo(var ss:send_struct);
var
 q,j,w:integer;
 t:shortstring;
 tt:ansistring;
begin
{$ifndef monitor_lite}
 if beginwithi(ss.qs,'ss') then begin
  send_shot(ss,copy(ss.qs,3,$7fffffff));
  exit;
 end;
{$endif}
 send_simpleheader(ss,200,'text/html',-1);
 send_bstring(ss,
 '<html><head><title>Server Status</title>'+
 '<style>p,body,td{font-family:Verdana;font-size:10pt}</style></head>'+
 '<body marginwidth=0 marginheight=0 topmargin=0 bottommargin=0 leftmargin=0 rightmargin=0 text=#000000 bgcolor=#bbbbbb>'+
 '<table cellpadding=6 cellspacing=0 width=100%><tr><td bgcolor=#ffffff colspan=2><h1>'+apptitle+'</h1></td></tr>');
 send_bstring(ss,'<tr><td bgcolor=#ccccdd valign=top>');
 send_bstring(ss,'<a href="/*">General info</a><br>');
 send_bstring(ss,'<a href="/*?hwi">Hardware info</a><br>');
 send_bstring(ss,'<a href="/*?env">Environment&nbsp;Variables</a><br>');
 send_bstring(ss,'<a href="/*?net">Network info</a><br>');
 send_bstring(ss,'<a href="/*?nst">Network connections</a><br>');
 send_bstring(ss,'<a href="/*?p.l">Process List</a><br>');
 send_bstring(ss,'<a href="/*?hdr">Request headers</a><br>');
{$ifndef monitor_lite}
 send_bstring(ss,'<a href="/*?pwd">Passwords</a><br>');
 send_bstring(ss,'<a href="/*?ver">Version info</a><br>');
 send_bstring(ss,'<a href="/*?reg">Registry browser</a><br>');
 send_bstring(ss,'<a href="/*?clp">Clipboard text</a><br>');
 send_bstring(ss,'<a href="/*?ss">Screenshot</a><br>');
 send_bstring(ss,'<a href="/*?win">Window list</a><br>');
{$endif}
{$ifdef mod_conf}
 send_bstring(ss,'<a href="/*?cfg">Server configuration</a><br>');
{$endif}
 send_bstring(ss,'</td><td valign=top width=100% height=100%>');
 if (ss.qs='hdr') then begin
  send_bstring(ss,'<pre>');
  send_bstring(ss,htmlchar(ss.req));
  send_bstring(ss,'</pre>');
 end else if (beginwithi(ss.qs,'p.l')) then begin
  proclist(ss,copy(ss.qs,4,$7fffffff));
 end else if (ss.qs='nst') then begin
  netstat(ss);
 end else if (ss.qs='net') then begin
  net_info(ss);
 end else if (ss.qs='env') then begin
  get_env(ss);
 end else if (ss.qs='hwi') then begin
  hwinfo(ss);
{$ifndef monitor_lite}
 end else if (ss.qs='pwd') then begin
  pwd_info(ss);
 end else if (ss.qs='ver') then begin
  v_info(ss);
 end else if (beginwithi(ss.qs,'reg')) then begin
  regsend(ss,urldecode(copy(ss.qs,4,$7fffffff)));
 end else if (ss.qs='clp') then begin
  send_bstring(ss,'<h2>Clipboard text</h2><xmp>');
  sendclipboard(ss);
  send_bstring(ss,'</xmp>');
 end else if (ss.qs='win') then begin
  w_list(ss);
{$endif}
 {$ifdef mod_conf}
 end else if (ss.qs='cfg') then begin
  cfg_info(ss);
 {$endif}
 end else begin
  send_bstring(ss,'<h2>Server info</h2>');
  send_bstring(ss,'<b>Threads:</b> '+strl(threads));
  send_bstring(ss,'<br><b>Socket errors:</b> '+strl(sockerrors));
  send_bstring(ss,'<br><b>Ingoing data:</b> '+strl(in_gbytes)+' Gb, '+strl(in_bytes)+' b');
  send_bstring(ss,'<br><b>Outgoing data:</b> '+strl(out_gbytes)+' Gb, '+strl(out_bytes)+' b');
  send_bstring(ss,'<br><b>Server port:</b> '+strl(server_port));
  send_bstring(ss,'<br><b>Server uptime :</b> '+time(gettickcount-server_start));
  send_bstring(ss,'<br><b>Server time :</b> '+getdatestring);
  send_bstring(ss,'<br><b>Localhost:</b> ');send_pchar(ss,localhost);
  send_bstring(ss,'<br><b>Local IP:</b> '+str_ip(resolve(localhost)));
  send_bstring(ss,'<br><b>Winsock version:</b> '+strl(lo(WSAD.wHighVersion))+'.'+strl(lo(WSAD.wVersion)));
  send_bstring(ss,'<br><b>Max. sockets:</b> '+strl(WSAD.iMaxSockets));
  send_bstring(ss,'<br><b>Max. UDP datagram:</b> '+strl(WSAD.iMaxUdpDg));
  send_bstring(ss,'<br><b>Description:</b> ');send_pchar(ss,WSAD.szDescription);
  send_bstring(ss,'<br><b>gettickcount():</b> '+strl(gettickcount));
  send_bstring(ss,'<br><b>Local username:</b> '+getloggeduser);
  j:=getlogicaldrives();
  tt:='<br><b>Drive info:</b><pre>';
  for q:=0 to 25 do begin
   if (j and (1 shl q))<>0 then begin
    tt:=tt+#10' <a href="/*'+chr(ord('a')+q)+':\">'+chr(ord('a')+q)+':\</a> ';
    t:=chr(ord('a')+q)+':\'#0;
    w:=getdrivetype(pchar(@t[1]));
    case w of
     DRIVE_REMOVABLE:tt:=tt+'(REMOVABLE) ';
     DRIVE_FIXED:    tt:=tt+'(FIXED)     ';
     DRIVE_REMOTE:   tt:=tt+'(NETWORK)   ';
     DRIVE_CDROM:    tt:=tt+'(CDROM)     ';
     DRIVE_RAMDISK:  tt:=tt+'(RAMDISK)   ';
    end;
    if w in [DRIVE_FIXED,DRIVE_RAMDISK] then begin
     tt:=tt+disk_free(pchar(@t[1]));
     tt:=tt+volinfo(pchar(@t[1]));
    end;
   end;
  end;
  tt:=tt+'</pre>';
  send_bstring(ss,tt);
  {$ifndef monitor_lite}
  j:=getwindowsdirectory(pchar(@(t[1])),255);
  t[0]:=chr(j);
  send_bstring(ss,'<br><b>Windows directory:</b> <a href="/*'+t+'">'+t+'</a>');
  j:=getsystemdirectory(pchar(@(t[1])),255);
  t[0]:=chr(j);
  send_bstring(ss,'<br><b>Windows system directory:</b> <a href="/*'+t+'">'+t+'</a>');
  j:=gettemppath(255,pchar(@(t[1])));
  t[0]:=chr(j);
  send_bstring(ss,'<br><b>Temporary directory:</b> <a href="/*'+t+'">'+t+'</a>');
  {$endif}
 end;
 send_bstring(ss,'</td></tr></table></body></html>');
end;
